#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 234
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 125
#define ALIAS_COUNT 0
#define TOKEN_COUNT 67
#define EXTERNAL_TOKEN_COUNT 6
#define FIELD_COUNT 20
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 50

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_return = 3,
  anon_sym_SEMI = 4,
  anon_sym_EQ = 5,
  anon_sym_COMMA = 6,
  anon_sym_COLON_COLON = 7,
  sym_break_statement = 8,
  anon_sym_goto = 9,
  anon_sym_do = 10,
  anon_sym_end = 11,
  anon_sym_while = 12,
  anon_sym_repeat = 13,
  anon_sym_until = 14,
  anon_sym_if = 15,
  anon_sym_then = 16,
  anon_sym_elseif = 17,
  anon_sym_else = 18,
  anon_sym_for = 19,
  anon_sym_in = 20,
  anon_sym_function = 21,
  anon_sym_local = 22,
  anon_sym_DOT = 23,
  anon_sym_COLON = 24,
  sym_nil = 25,
  sym_false = 26,
  sym_true = 27,
  sym_number = 28,
  sym_vararg_expression = 29,
  anon_sym_LPAREN = 30,
  anon_sym_RPAREN = 31,
  anon_sym_LBRACK = 32,
  anon_sym_RBRACK = 33,
  anon_sym_LBRACE = 34,
  anon_sym_RBRACE = 35,
  anon_sym_or = 36,
  anon_sym_and = 37,
  anon_sym_LT = 38,
  anon_sym_LT_EQ = 39,
  anon_sym_EQ_EQ = 40,
  anon_sym_TILDE_EQ = 41,
  anon_sym_GT_EQ = 42,
  anon_sym_GT = 43,
  anon_sym_PIPE = 44,
  anon_sym_TILDE = 45,
  anon_sym_AMP = 46,
  anon_sym_LT_LT = 47,
  anon_sym_GT_GT = 48,
  anon_sym_PLUS = 49,
  anon_sym_DASH = 50,
  anon_sym_STAR = 51,
  anon_sym_SLASH = 52,
  anon_sym_SLASH_SLASH = 53,
  anon_sym_PERCENT = 54,
  anon_sym_DOT_DOT = 55,
  anon_sym_CARET = 56,
  anon_sym_not = 57,
  anon_sym_POUND = 58,
  anon_sym_DASH_DASH = 59,
  aux_sym_comment_token1 = 60,
  sym__block_comment_start = 61,
  sym__block_comment_content = 62,
  sym__block_comment_end = 63,
  sym__string_start = 64,
  sym__string_content = 65,
  sym__string_end = 66,
  sym_chunk = 67,
  sym__block = 68,
  sym_statement = 69,
  sym_return_statement = 70,
  sym_empty_statement = 71,
  sym_assignment_statement = 72,
  sym__variable_assignment_varlist = 73,
  sym__variable_assignment_explist = 74,
  sym_label_statement = 75,
  sym_goto_statement = 76,
  sym_do_statement = 77,
  sym_while_statement = 78,
  sym_repeat_statement = 79,
  sym_if_statement = 80,
  sym_elseif_statement = 81,
  sym_else_statement = 82,
  sym_for_statement = 83,
  sym_for_generic_clause = 84,
  sym_for_numeric_clause = 85,
  sym_declaration = 86,
  sym_function_declaration = 87,
  sym__local_function_declaration = 88,
  sym__function_name = 89,
  sym__function_name_prefix_expression = 90,
  sym__function_name_dot_index_expression = 91,
  sym__function_name_method_index_expression = 92,
  sym_variable_declaration = 93,
  sym__local_variable_assignment = 94,
  sym__name_list = 95,
  sym__expression_list = 96,
  sym_expression = 97,
  sym_string = 98,
  sym_function_definition = 99,
  sym__function_body = 100,
  sym_parameters = 101,
  sym__parameter_list = 102,
  sym__prefix_expression = 103,
  sym_variable = 104,
  sym_bracket_index_expression = 105,
  sym_dot_index_expression = 106,
  sym_function_call = 107,
  sym_method_index_expression = 108,
  sym_arguments = 109,
  sym_parenthesized_expression = 110,
  sym_table_constructor = 111,
  sym__field_list = 112,
  sym__field_sep = 113,
  sym_field = 114,
  sym_binary_expression = 115,
  sym_unary_expression = 116,
  sym_comment = 117,
  aux_sym_chunk_repeat1 = 118,
  aux_sym__variable_assignment_varlist_repeat1 = 119,
  aux_sym__variable_assignment_explist_repeat1 = 120,
  aux_sym_if_statement_repeat1 = 121,
  aux_sym__name_list_repeat1 = 122,
  aux_sym__expression_list_repeat1 = 123,
  aux_sym__field_list_repeat1 = 124,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_return] = "return",
  [anon_sym_SEMI] = ";",
  [anon_sym_EQ] = "=",
  [anon_sym_COMMA] = ",",
  [anon_sym_COLON_COLON] = "::",
  [sym_break_statement] = "break_statement",
  [anon_sym_goto] = "goto",
  [anon_sym_do] = "do",
  [anon_sym_end] = "end",
  [anon_sym_while] = "while",
  [anon_sym_repeat] = "repeat",
  [anon_sym_until] = "until",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_elseif] = "elseif",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_function] = "function",
  [anon_sym_local] = "local",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON] = ":",
  [sym_nil] = "nil",
  [sym_false] = "false",
  [sym_true] = "true",
  [sym_number] = "number",
  [sym_vararg_expression] = "vararg_expression",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_or] = "or",
  [anon_sym_and] = "and",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_TILDE_EQ] = "~=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_PIPE] = "|",
  [anon_sym_TILDE] = "~",
  [anon_sym_AMP] = "&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_CARET] = "^",
  [anon_sym_not] = "not",
  [anon_sym_POUND] = "#",
  [anon_sym_DASH_DASH] = "comment_start",
  [aux_sym_comment_token1] = "comment_content",
  [sym__block_comment_start] = "comment_start",
  [sym__block_comment_content] = "comment_content",
  [sym__block_comment_end] = "comment_end",
  [sym__string_start] = "string_start",
  [sym__string_content] = "string_content",
  [sym__string_end] = "string_end",
  [sym_chunk] = "chunk",
  [sym__block] = "block",
  [sym_statement] = "statement",
  [sym_return_statement] = "return_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_assignment_statement] = "assignment_statement",
  [sym__variable_assignment_varlist] = "variable_list",
  [sym__variable_assignment_explist] = "expression_list",
  [sym_label_statement] = "label_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_do_statement] = "do_statement",
  [sym_while_statement] = "while_statement",
  [sym_repeat_statement] = "repeat_statement",
  [sym_if_statement] = "if_statement",
  [sym_elseif_statement] = "elseif_statement",
  [sym_else_statement] = "else_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_generic_clause] = "for_generic_clause",
  [sym_for_numeric_clause] = "for_numeric_clause",
  [sym_declaration] = "declaration",
  [sym_function_declaration] = "function_declaration",
  [sym__local_function_declaration] = "function_declaration",
  [sym__function_name] = "_function_name",
  [sym__function_name_prefix_expression] = "_function_name_prefix_expression",
  [sym__function_name_dot_index_expression] = "dot_index_expression",
  [sym__function_name_method_index_expression] = "method_index_expression",
  [sym_variable_declaration] = "variable_declaration",
  [sym__local_variable_assignment] = "assignment_statement",
  [sym__name_list] = "variable_list",
  [sym__expression_list] = "expression_list",
  [sym_expression] = "expression",
  [sym_string] = "string",
  [sym_function_definition] = "function_definition",
  [sym__function_body] = "_function_body",
  [sym_parameters] = "parameters",
  [sym__parameter_list] = "_parameter_list",
  [sym__prefix_expression] = "_prefix_expression",
  [sym_variable] = "variable",
  [sym_bracket_index_expression] = "bracket_index_expression",
  [sym_dot_index_expression] = "dot_index_expression",
  [sym_function_call] = "function_call",
  [sym_method_index_expression] = "method_index_expression",
  [sym_arguments] = "arguments",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_table_constructor] = "table_constructor",
  [sym__field_list] = "_field_list",
  [sym__field_sep] = "_field_sep",
  [sym_field] = "field",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_comment] = "comment",
  [aux_sym_chunk_repeat1] = "chunk_repeat1",
  [aux_sym__variable_assignment_varlist_repeat1] = "_variable_assignment_varlist_repeat1",
  [aux_sym__variable_assignment_explist_repeat1] = "_variable_assignment_explist_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym__name_list_repeat1] = "_name_list_repeat1",
  [aux_sym__expression_list_repeat1] = "_expression_list_repeat1",
  [aux_sym__field_list_repeat1] = "_field_list_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [sym_break_statement] = sym_break_statement,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_repeat] = anon_sym_repeat,
  [anon_sym_until] = anon_sym_until,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_elseif] = anon_sym_elseif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_local] = anon_sym_local,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_COLON] = anon_sym_COLON,
  [sym_nil] = sym_nil,
  [sym_false] = sym_false,
  [sym_true] = sym_true,
  [sym_number] = sym_number,
  [sym_vararg_expression] = sym_vararg_expression,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_TILDE_EQ] = anon_sym_TILDE_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_DASH_DASH] = sym__block_comment_start,
  [aux_sym_comment_token1] = sym__block_comment_content,
  [sym__block_comment_start] = sym__block_comment_start,
  [sym__block_comment_content] = sym__block_comment_content,
  [sym__block_comment_end] = sym__block_comment_end,
  [sym__string_start] = sym__string_start,
  [sym__string_content] = sym__string_content,
  [sym__string_end] = sym__string_end,
  [sym_chunk] = sym_chunk,
  [sym__block] = sym__block,
  [sym_statement] = sym_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_assignment_statement] = sym_assignment_statement,
  [sym__variable_assignment_varlist] = sym__variable_assignment_varlist,
  [sym__variable_assignment_explist] = sym__variable_assignment_explist,
  [sym_label_statement] = sym_label_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_repeat_statement] = sym_repeat_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_elseif_statement] = sym_elseif_statement,
  [sym_else_statement] = sym_else_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_generic_clause] = sym_for_generic_clause,
  [sym_for_numeric_clause] = sym_for_numeric_clause,
  [sym_declaration] = sym_declaration,
  [sym_function_declaration] = sym_function_declaration,
  [sym__local_function_declaration] = sym_function_declaration,
  [sym__function_name] = sym__function_name,
  [sym__function_name_prefix_expression] = sym__function_name_prefix_expression,
  [sym__function_name_dot_index_expression] = sym_dot_index_expression,
  [sym__function_name_method_index_expression] = sym_method_index_expression,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym__local_variable_assignment] = sym_assignment_statement,
  [sym__name_list] = sym__variable_assignment_varlist,
  [sym__expression_list] = sym__variable_assignment_explist,
  [sym_expression] = sym_expression,
  [sym_string] = sym_string,
  [sym_function_definition] = sym_function_definition,
  [sym__function_body] = sym__function_body,
  [sym_parameters] = sym_parameters,
  [sym__parameter_list] = sym__parameter_list,
  [sym__prefix_expression] = sym__prefix_expression,
  [sym_variable] = sym_variable,
  [sym_bracket_index_expression] = sym_bracket_index_expression,
  [sym_dot_index_expression] = sym_dot_index_expression,
  [sym_function_call] = sym_function_call,
  [sym_method_index_expression] = sym_method_index_expression,
  [sym_arguments] = sym_arguments,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_table_constructor] = sym_table_constructor,
  [sym__field_list] = sym__field_list,
  [sym__field_sep] = sym__field_sep,
  [sym_field] = sym_field,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_comment] = sym_comment,
  [aux_sym_chunk_repeat1] = aux_sym_chunk_repeat1,
  [aux_sym__variable_assignment_varlist_repeat1] = aux_sym__variable_assignment_varlist_repeat1,
  [aux_sym__variable_assignment_explist_repeat1] = aux_sym__variable_assignment_explist_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym__name_list_repeat1] = aux_sym__name_list_repeat1,
  [aux_sym__expression_list_repeat1] = aux_sym__expression_list_repeat1,
  [aux_sym__field_list_repeat1] = aux_sym__field_list_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_repeat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elseif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_vararg_expression] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_comment_token1] = {
    .visible = true,
    .named = false,
  },
  [sym__block_comment_start] = {
    .visible = true,
    .named = false,
  },
  [sym__block_comment_content] = {
    .visible = true,
    .named = false,
  },
  [sym__block_comment_end] = {
    .visible = true,
    .named = false,
  },
  [sym__string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = true,
    .named = false,
  },
  [sym__string_end] = {
    .visible = true,
    .named = false,
  },
  [sym_chunk] = {
    .visible = true,
    .named = true,
  },
  [sym__block] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_assignment_varlist] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_assignment_explist] = {
    .visible = true,
    .named = true,
  },
  [sym_label_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_generic_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_numeric_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__local_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__function_name] = {
    .visible = false,
    .named = true,
  },
  [sym__function_name_prefix_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__function_name_dot_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__function_name_method_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__local_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__name_list] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__function_body] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_list] = {
    .visible = false,
    .named = true,
  },
  [sym__prefix_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_variable] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_bracket_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_dot_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_call] = {
    .visible = true,
    .named = true,
  },
  [sym_method_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_table_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym__field_list] = {
    .visible = false,
    .named = true,
  },
  [sym__field_sep] = {
    .visible = false,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_chunk_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__variable_assignment_varlist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__variable_assignment_explist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__name_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__field_list_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_alternative = 1,
  field_arguments = 2,
  field_body = 3,
  field_clause = 4,
  field_condition = 5,
  field_consequence = 6,
  field_content = 7,
  field_end = 8,
  field_field = 9,
  field_left = 10,
  field_local_declaration = 11,
  field_method = 12,
  field_name = 13,
  field_operand = 14,
  field_parameters = 15,
  field_right = 16,
  field_start = 17,
  field_step = 18,
  field_table = 19,
  field_value = 20,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_clause] = "clause",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_content] = "content",
  [field_end] = "end",
  [field_field] = "field",
  [field_left] = "left",
  [field_local_declaration] = "local_declaration",
  [field_method] = "method",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_parameters] = "parameters",
  [field_right] = "right",
  [field_start] = "start",
  [field_step] = "step",
  [field_table] = "table",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 4},
  [3] = {.index = 5, .length = 1},
  [4] = {.index = 6, .length = 1},
  [5] = {.index = 7, .length = 2},
  [6] = {.index = 9, .length = 2},
  [7] = {.index = 11, .length = 2},
  [8] = {.index = 13, .length = 2},
  [9] = {.index = 15, .length = 1},
  [10] = {.index = 16, .length = 2},
  [11] = {.index = 18, .length = 2},
  [12] = {.index = 20, .length = 3},
  [13] = {.index = 23, .length = 2},
  [14] = {.index = 25, .length = 1},
  [15] = {.index = 26, .length = 1},
  [16] = {.index = 27, .length = 1},
  [17] = {.index = 28, .length = 1},
  [18] = {.index = 29, .length = 3},
  [19] = {.index = 32, .length = 2},
  [20] = {.index = 34, .length = 2},
  [21] = {.index = 36, .length = 2},
  [22] = {.index = 38, .length = 1},
  [23] = {.index = 39, .length = 2},
  [24] = {.index = 41, .length = 1},
  [25] = {.index = 42, .length = 2},
  [26] = {.index = 44, .length = 1},
  [27] = {.index = 45, .length = 2},
  [28] = {.index = 47, .length = 1},
  [29] = {.index = 48, .length = 1},
  [30] = {.index = 49, .length = 1},
  [31] = {.index = 50, .length = 3},
  [32] = {.index = 53, .length = 2},
  [33] = {.index = 55, .length = 2},
  [34] = {.index = 57, .length = 2},
  [35] = {.index = 59, .length = 2},
  [36] = {.index = 61, .length = 2},
  [37] = {.index = 63, .length = 2},
  [38] = {.index = 65, .length = 2},
  [39] = {.index = 67, .length = 2},
  [40] = {.index = 69, .length = 2},
  [41] = {.index = 71, .length = 1},
  [42] = {.index = 72, .length = 2},
  [43] = {.index = 74, .length = 3},
  [44] = {.index = 77, .length = 3},
  [45] = {.index = 80, .length = 3},
  [46] = {.index = 83, .length = 3},
  [47] = {.index = 86, .length = 2},
  [48] = {.index = 88, .length = 4},
  [49] = {.index = 92, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_local_declaration, 0, .inherited = true},
  [1] =
    {field_body, 0, .inherited = true},
    {field_local_declaration, 0},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
  [5] =
    {field_local_declaration, 0},
  [6] =
    {field_name, 0},
  [7] =
    {field_end, 1},
    {field_start, 0},
  [9] =
    {field_content, 1},
    {field_start, 0},
  [11] =
    {field_field, 0, .inherited = true},
    {field_table, 0, .inherited = true},
  [13] =
    {field_method, 0, .inherited = true},
    {field_table, 0, .inherited = true},
  [15] =
    {field_name, 1, .inherited = true},
  [16] =
    {field_arguments, 1},
    {field_name, 0},
  [18] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [20] =
    {field_content, 1},
    {field_end, 2},
    {field_start, 0},
  [23] =
    {field_body, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
  [25] =
    {field_value, 0},
  [26] =
    {field_operand, 1},
  [27] =
    {field_body, 1},
  [28] =
    {field_condition, 2},
  [29] =
    {field_body, 2, .inherited = true},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
  [32] =
    {field_name, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [34] =
    {field_field, 2},
    {field_table, 0},
  [36] =
    {field_method, 2},
    {field_table, 0},
  [38] =
    {field_name, 1},
  [39] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [41] =
    {field_parameters, 0},
  [42] =
    {field_left, 0},
    {field_right, 2},
  [44] =
    {field_condition, 1},
  [45] =
    {field_body, 1},
    {field_condition, 3},
  [47] =
    {field_alternative, 0},
  [48] =
    {field_clause, 1},
  [49] =
    {field_name, 0, .inherited = true},
  [50] =
    {field_body, 3, .inherited = true},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
  [53] =
    {field_value, 0},
    {field_value, 1, .inherited = true},
  [55] =
    {field_body, 1},
    {field_parameters, 0},
  [57] =
    {field_name, 0},
    {field_value, 2},
  [59] =
    {field_body, 3},
    {field_condition, 1},
  [61] =
    {field_condition, 1},
    {field_consequence, 3},
  [63] =
    {field_alternative, 3},
    {field_condition, 1},
  [65] =
    {field_alternative, 3, .inherited = true},
    {field_condition, 1},
  [67] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [69] =
    {field_body, 3},
    {field_clause, 1},
  [71] =
    {field_value, 1},
  [72] =
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [74] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 3},
  [77] =
    {field_alternative, 4, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
  [80] =
    {field_alternative, 3, .inherited = true},
    {field_alternative, 4},
    {field_condition, 1},
  [83] =
    {field_end, 4},
    {field_name, 0},
    {field_start, 2},
  [86] =
    {field_name, 1},
    {field_value, 4},
  [88] =
    {field_alternative, 4, .inherited = true},
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
  [92] =
    {field_end, 4},
    {field_name, 0},
    {field_start, 2},
    {field_step, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(10);
      if (lookahead == '#') ADVANCE(53);
      if (lookahead == '%') ADVANCE(49);
      if (lookahead == '&') ADVANCE(41);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == '*') ADVANCE(46);
      if (lookahead == '+') ADVANCE(44);
      if (lookahead == ',') ADVANCE(14);
      if (lookahead == '-') ADVANCE(45);
      if (lookahead == '.') ADVANCE(17);
      if (lookahead == '/') ADVANCE(47);
      if (lookahead == '0') ADVANCE(19);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == ';') ADVANCE(12);
      if (lookahead == '<') ADVANCE(32);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(37);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '^') ADVANCE(51);
      if (lookahead == '{') ADVANCE(30);
      if (lookahead == '|') ADVANCE(38);
      if (lookahead == '}') ADVANCE(31);
      if (lookahead == '~') ADVANCE(40);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(20);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(54);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(11);
      END_STATE();
    case 2:
      if (lookahead == '.') ADVANCE(3);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(22);
      END_STATE();
    case 3:
      if (lookahead == '.') ADVANCE(25);
      END_STATE();
    case 4:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(24);
      END_STATE();
    case 5:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(24);
      END_STATE();
    case 6:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(21);
      END_STATE();
    case 7:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(23);
      END_STATE();
    case 8:
      if (eof) ADVANCE(10);
      if (lookahead == '#') ADVANCE(1);
      if (lookahead == '%') ADVANCE(49);
      if (lookahead == '&') ADVANCE(41);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == '*') ADVANCE(46);
      if (lookahead == '+') ADVANCE(44);
      if (lookahead == ',') ADVANCE(14);
      if (lookahead == '-') ADVANCE(45);
      if (lookahead == '.') ADVANCE(16);
      if (lookahead == '/') ADVANCE(47);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == ';') ADVANCE(12);
      if (lookahead == '<') ADVANCE(32);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(37);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '^') ADVANCE(51);
      if (lookahead == '{') ADVANCE(30);
      if (lookahead == '|') ADVANCE(38);
      if (lookahead == '}') ADVANCE(31);
      if (lookahead == '~') ADVANCE(40);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(8)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(54);
      END_STATE();
    case 9:
      if (eof) ADVANCE(10);
      if (lookahead == '#') ADVANCE(52);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == '-') ADVANCE(45);
      if (lookahead == '.') ADVANCE(2);
      if (lookahead == '0') ADVANCE(19);
      if (lookahead == ';') ADVANCE(12);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '{') ADVANCE(30);
      if (lookahead == '}') ADVANCE(31);
      if (lookahead == '~') ADVANCE(39);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(9)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(20);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(54);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(11);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(34);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(50);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(22);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(15);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(22);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(4);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(6);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(20);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(22);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(20);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(7);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(21);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(22);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(23);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(24);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(sym_vararg_expression);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(42);
      if (lookahead == '=') ADVANCE(33);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_TILDE_EQ);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(36);
      if (lookahead == '>') ADVANCE(43);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '=') ADVANCE(35);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(55);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(48);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '!') ADVANCE(11);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(54);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(59);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '-') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(59);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '-') ADVANCE(56);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(59);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(59);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'd') ADVANCE(3);
      if (lookahead == 'e') ADVANCE(4);
      if (lookahead == 'f') ADVANCE(5);
      if (lookahead == 'g') ADVANCE(6);
      if (lookahead == 'i') ADVANCE(7);
      if (lookahead == 'l') ADVANCE(8);
      if (lookahead == 'n') ADVANCE(9);
      if (lookahead == 'o') ADVANCE(10);
      if (lookahead == 'r') ADVANCE(11);
      if (lookahead == 't') ADVANCE(12);
      if (lookahead == 'u') ADVANCE(13);
      if (lookahead == 'w') ADVANCE(14);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'n') ADVANCE(15);
      END_STATE();
    case 2:
      if (lookahead == 'r') ADVANCE(16);
      END_STATE();
    case 3:
      if (lookahead == 'o') ADVANCE(17);
      END_STATE();
    case 4:
      if (lookahead == 'l') ADVANCE(18);
      if (lookahead == 'n') ADVANCE(19);
      END_STATE();
    case 5:
      if (lookahead == 'a') ADVANCE(20);
      if (lookahead == 'o') ADVANCE(21);
      if (lookahead == 'u') ADVANCE(22);
      END_STATE();
    case 6:
      if (lookahead == 'o') ADVANCE(23);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(24);
      if (lookahead == 'n') ADVANCE(25);
      END_STATE();
    case 8:
      if (lookahead == 'o') ADVANCE(26);
      END_STATE();
    case 9:
      if (lookahead == 'i') ADVANCE(27);
      if (lookahead == 'o') ADVANCE(28);
      END_STATE();
    case 10:
      if (lookahead == 'r') ADVANCE(29);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(30);
      END_STATE();
    case 12:
      if (lookahead == 'h') ADVANCE(31);
      if (lookahead == 'r') ADVANCE(32);
      END_STATE();
    case 13:
      if (lookahead == 'n') ADVANCE(33);
      END_STATE();
    case 14:
      if (lookahead == 'h') ADVANCE(34);
      END_STATE();
    case 15:
      if (lookahead == 'd') ADVANCE(35);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(36);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 18:
      if (lookahead == 's') ADVANCE(37);
      END_STATE();
    case 19:
      if (lookahead == 'd') ADVANCE(38);
      END_STATE();
    case 20:
      if (lookahead == 'l') ADVANCE(39);
      END_STATE();
    case 21:
      if (lookahead == 'r') ADVANCE(40);
      END_STATE();
    case 22:
      if (lookahead == 'n') ADVANCE(41);
      END_STATE();
    case 23:
      if (lookahead == 't') ADVANCE(42);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 26:
      if (lookahead == 'c') ADVANCE(43);
      END_STATE();
    case 27:
      if (lookahead == 'l') ADVANCE(44);
      END_STATE();
    case 28:
      if (lookahead == 't') ADVANCE(45);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 30:
      if (lookahead == 'p') ADVANCE(46);
      if (lookahead == 't') ADVANCE(47);
      END_STATE();
    case 31:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 32:
      if (lookahead == 'u') ADVANCE(49);
      END_STATE();
    case 33:
      if (lookahead == 't') ADVANCE(50);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(51);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 36:
      if (lookahead == 'a') ADVANCE(52);
      END_STATE();
    case 37:
      if (lookahead == 'e') ADVANCE(53);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 39:
      if (lookahead == 's') ADVANCE(54);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 41:
      if (lookahead == 'c') ADVANCE(55);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(56);
      END_STATE();
    case 43:
      if (lookahead == 'a') ADVANCE(57);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_nil);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(58);
      END_STATE();
    case 47:
      if (lookahead == 'u') ADVANCE(59);
      END_STATE();
    case 48:
      if (lookahead == 'n') ADVANCE(60);
      END_STATE();
    case 49:
      if (lookahead == 'e') ADVANCE(61);
      END_STATE();
    case 50:
      if (lookahead == 'i') ADVANCE(62);
      END_STATE();
    case 51:
      if (lookahead == 'l') ADVANCE(63);
      END_STATE();
    case 52:
      if (lookahead == 'k') ADVANCE(64);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(65);
      END_STATE();
    case 54:
      if (lookahead == 'e') ADVANCE(66);
      END_STATE();
    case 55:
      if (lookahead == 't') ADVANCE(67);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 57:
      if (lookahead == 'l') ADVANCE(68);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(69);
      END_STATE();
    case 59:
      if (lookahead == 'r') ADVANCE(70);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 62:
      if (lookahead == 'l') ADVANCE(71);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(72);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_break_statement);
      END_STATE();
    case 65:
      if (lookahead == 'f') ADVANCE(73);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(74);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 69:
      if (lookahead == 't') ADVANCE(75);
      END_STATE();
    case 70:
      if (lookahead == 'n') ADVANCE(76);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_elseif);
      END_STATE();
    case 74:
      if (lookahead == 'o') ADVANCE(77);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_repeat);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 77:
      if (lookahead == 'n') ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 8, .external_lex_state = 2},
  [2] = {.lex_state = 8, .external_lex_state = 3},
  [3] = {.lex_state = 8, .external_lex_state = 3},
  [4] = {.lex_state = 8, .external_lex_state = 3},
  [5] = {.lex_state = 8, .external_lex_state = 3},
  [6] = {.lex_state = 8, .external_lex_state = 3},
  [7] = {.lex_state = 8, .external_lex_state = 3},
  [8] = {.lex_state = 8, .external_lex_state = 3},
  [9] = {.lex_state = 8, .external_lex_state = 3},
  [10] = {.lex_state = 8, .external_lex_state = 3},
  [11] = {.lex_state = 8, .external_lex_state = 3},
  [12] = {.lex_state = 8, .external_lex_state = 3},
  [13] = {.lex_state = 8, .external_lex_state = 3},
  [14] = {.lex_state = 8, .external_lex_state = 3},
  [15] = {.lex_state = 8, .external_lex_state = 3},
  [16] = {.lex_state = 0, .external_lex_state = 2},
  [17] = {.lex_state = 0, .external_lex_state = 2},
  [18] = {.lex_state = 0, .external_lex_state = 2},
  [19] = {.lex_state = 0, .external_lex_state = 2},
  [20] = {.lex_state = 0, .external_lex_state = 2},
  [21] = {.lex_state = 0, .external_lex_state = 2},
  [22] = {.lex_state = 0, .external_lex_state = 2},
  [23] = {.lex_state = 0, .external_lex_state = 2},
  [24] = {.lex_state = 0, .external_lex_state = 2},
  [25] = {.lex_state = 0, .external_lex_state = 2},
  [26] = {.lex_state = 0, .external_lex_state = 2},
  [27] = {.lex_state = 0, .external_lex_state = 2},
  [28] = {.lex_state = 0, .external_lex_state = 2},
  [29] = {.lex_state = 0, .external_lex_state = 2},
  [30] = {.lex_state = 0, .external_lex_state = 2},
  [31] = {.lex_state = 0, .external_lex_state = 2},
  [32] = {.lex_state = 0, .external_lex_state = 2},
  [33] = {.lex_state = 0, .external_lex_state = 2},
  [34] = {.lex_state = 0, .external_lex_state = 2},
  [35] = {.lex_state = 0, .external_lex_state = 2},
  [36] = {.lex_state = 0, .external_lex_state = 2},
  [37] = {.lex_state = 0, .external_lex_state = 2},
  [38] = {.lex_state = 0, .external_lex_state = 2},
  [39] = {.lex_state = 0, .external_lex_state = 2},
  [40] = {.lex_state = 0, .external_lex_state = 2},
  [41] = {.lex_state = 0, .external_lex_state = 2},
  [42] = {.lex_state = 0, .external_lex_state = 2},
  [43] = {.lex_state = 0, .external_lex_state = 2},
  [44] = {.lex_state = 0, .external_lex_state = 2},
  [45] = {.lex_state = 0, .external_lex_state = 2},
  [46] = {.lex_state = 0, .external_lex_state = 2},
  [47] = {.lex_state = 0, .external_lex_state = 2},
  [48] = {.lex_state = 0, .external_lex_state = 2},
  [49] = {.lex_state = 0, .external_lex_state = 2},
  [50] = {.lex_state = 0, .external_lex_state = 2},
  [51] = {.lex_state = 0, .external_lex_state = 2},
  [52] = {.lex_state = 0, .external_lex_state = 2},
  [53] = {.lex_state = 9, .external_lex_state = 3},
  [54] = {.lex_state = 9, .external_lex_state = 3},
  [55] = {.lex_state = 9, .external_lex_state = 3},
  [56] = {.lex_state = 8, .external_lex_state = 3},
  [57] = {.lex_state = 9, .external_lex_state = 3},
  [58] = {.lex_state = 0, .external_lex_state = 2},
  [59] = {.lex_state = 9, .external_lex_state = 3},
  [60] = {.lex_state = 0, .external_lex_state = 2},
  [61] = {.lex_state = 9, .external_lex_state = 3},
  [62] = {.lex_state = 9, .external_lex_state = 3},
  [63] = {.lex_state = 9, .external_lex_state = 3},
  [64] = {.lex_state = 9, .external_lex_state = 3},
  [65] = {.lex_state = 9, .external_lex_state = 3},
  [66] = {.lex_state = 9, .external_lex_state = 3},
  [67] = {.lex_state = 9, .external_lex_state = 3},
  [68] = {.lex_state = 9, .external_lex_state = 3},
  [69] = {.lex_state = 9, .external_lex_state = 3},
  [70] = {.lex_state = 9, .external_lex_state = 3},
  [71] = {.lex_state = 9, .external_lex_state = 3},
  [72] = {.lex_state = 9, .external_lex_state = 3},
  [73] = {.lex_state = 9, .external_lex_state = 3},
  [74] = {.lex_state = 9, .external_lex_state = 3},
  [75] = {.lex_state = 9, .external_lex_state = 3},
  [76] = {.lex_state = 9, .external_lex_state = 3},
  [77] = {.lex_state = 9, .external_lex_state = 3},
  [78] = {.lex_state = 9, .external_lex_state = 3},
  [79] = {.lex_state = 9, .external_lex_state = 3},
  [80] = {.lex_state = 9, .external_lex_state = 3},
  [81] = {.lex_state = 9, .external_lex_state = 3},
  [82] = {.lex_state = 9, .external_lex_state = 3},
  [83] = {.lex_state = 9, .external_lex_state = 3},
  [84] = {.lex_state = 9, .external_lex_state = 3},
  [85] = {.lex_state = 9, .external_lex_state = 3},
  [86] = {.lex_state = 9, .external_lex_state = 3},
  [87] = {.lex_state = 9, .external_lex_state = 3},
  [88] = {.lex_state = 9, .external_lex_state = 3},
  [89] = {.lex_state = 9, .external_lex_state = 3},
  [90] = {.lex_state = 9, .external_lex_state = 3},
  [91] = {.lex_state = 9, .external_lex_state = 3},
  [92] = {.lex_state = 9, .external_lex_state = 3},
  [93] = {.lex_state = 0, .external_lex_state = 2},
  [94] = {.lex_state = 0, .external_lex_state = 2},
  [95] = {.lex_state = 0, .external_lex_state = 2},
  [96] = {.lex_state = 8, .external_lex_state = 3},
  [97] = {.lex_state = 0, .external_lex_state = 2},
  [98] = {.lex_state = 0, .external_lex_state = 2},
  [99] = {.lex_state = 0, .external_lex_state = 2},
  [100] = {.lex_state = 0, .external_lex_state = 2},
  [101] = {.lex_state = 0, .external_lex_state = 2},
  [102] = {.lex_state = 0, .external_lex_state = 2},
  [103] = {.lex_state = 0, .external_lex_state = 2},
  [104] = {.lex_state = 0, .external_lex_state = 2},
  [105] = {.lex_state = 0, .external_lex_state = 2},
  [106] = {.lex_state = 0, .external_lex_state = 2},
  [107] = {.lex_state = 0, .external_lex_state = 2},
  [108] = {.lex_state = 0, .external_lex_state = 2},
  [109] = {.lex_state = 0, .external_lex_state = 2},
  [110] = {.lex_state = 0, .external_lex_state = 2},
  [111] = {.lex_state = 0, .external_lex_state = 2},
  [112] = {.lex_state = 0, .external_lex_state = 2},
  [113] = {.lex_state = 0, .external_lex_state = 2},
  [114] = {.lex_state = 0, .external_lex_state = 2},
  [115] = {.lex_state = 0, .external_lex_state = 2},
  [116] = {.lex_state = 0, .external_lex_state = 2},
  [117] = {.lex_state = 0, .external_lex_state = 2},
  [118] = {.lex_state = 0, .external_lex_state = 2},
  [119] = {.lex_state = 0, .external_lex_state = 2},
  [120] = {.lex_state = 0, .external_lex_state = 2},
  [121] = {.lex_state = 0, .external_lex_state = 2},
  [122] = {.lex_state = 0, .external_lex_state = 2},
  [123] = {.lex_state = 0, .external_lex_state = 2},
  [124] = {.lex_state = 0, .external_lex_state = 2},
  [125] = {.lex_state = 0, .external_lex_state = 2},
  [126] = {.lex_state = 0, .external_lex_state = 2},
  [127] = {.lex_state = 0, .external_lex_state = 2},
  [128] = {.lex_state = 0, .external_lex_state = 2},
  [129] = {.lex_state = 0, .external_lex_state = 2},
  [130] = {.lex_state = 0, .external_lex_state = 2},
  [131] = {.lex_state = 0, .external_lex_state = 2},
  [132] = {.lex_state = 0, .external_lex_state = 2},
  [133] = {.lex_state = 0, .external_lex_state = 2},
  [134] = {.lex_state = 0, .external_lex_state = 2},
  [135] = {.lex_state = 0, .external_lex_state = 2},
  [136] = {.lex_state = 0, .external_lex_state = 2},
  [137] = {.lex_state = 0, .external_lex_state = 2},
  [138] = {.lex_state = 0, .external_lex_state = 2},
  [139] = {.lex_state = 0, .external_lex_state = 2},
  [140] = {.lex_state = 0, .external_lex_state = 2},
  [141] = {.lex_state = 0, .external_lex_state = 2},
  [142] = {.lex_state = 9, .external_lex_state = 3},
  [143] = {.lex_state = 0, .external_lex_state = 2},
  [144] = {.lex_state = 0, .external_lex_state = 2},
  [145] = {.lex_state = 0, .external_lex_state = 2},
  [146] = {.lex_state = 0, .external_lex_state = 2},
  [147] = {.lex_state = 0, .external_lex_state = 2},
  [148] = {.lex_state = 8, .external_lex_state = 3},
  [149] = {.lex_state = 8, .external_lex_state = 3},
  [150] = {.lex_state = 8, .external_lex_state = 3},
  [151] = {.lex_state = 0, .external_lex_state = 3},
  [152] = {.lex_state = 0, .external_lex_state = 2},
  [153] = {.lex_state = 0, .external_lex_state = 2},
  [154] = {.lex_state = 8, .external_lex_state = 3},
  [155] = {.lex_state = 0, .external_lex_state = 2},
  [156] = {.lex_state = 0, .external_lex_state = 2},
  [157] = {.lex_state = 0, .external_lex_state = 2},
  [158] = {.lex_state = 0, .external_lex_state = 2},
  [159] = {.lex_state = 0, .external_lex_state = 2},
  [160] = {.lex_state = 0, .external_lex_state = 2},
  [161] = {.lex_state = 0, .external_lex_state = 2},
  [162] = {.lex_state = 0, .external_lex_state = 2},
  [163] = {.lex_state = 0, .external_lex_state = 2},
  [164] = {.lex_state = 0, .external_lex_state = 2},
  [165] = {.lex_state = 0, .external_lex_state = 2},
  [166] = {.lex_state = 0, .external_lex_state = 2},
  [167] = {.lex_state = 9, .external_lex_state = 2},
  [168] = {.lex_state = 0, .external_lex_state = 2},
  [169] = {.lex_state = 0, .external_lex_state = 2},
  [170] = {.lex_state = 0, .external_lex_state = 2},
  [171] = {.lex_state = 8, .external_lex_state = 2},
  [172] = {.lex_state = 0, .external_lex_state = 2},
  [173] = {.lex_state = 0, .external_lex_state = 2},
  [174] = {.lex_state = 8, .external_lex_state = 2},
  [175] = {.lex_state = 0, .external_lex_state = 3},
  [176] = {.lex_state = 0, .external_lex_state = 2},
  [177] = {.lex_state = 0, .external_lex_state = 2},
  [178] = {.lex_state = 0, .external_lex_state = 2},
  [179] = {.lex_state = 0, .external_lex_state = 2},
  [180] = {.lex_state = 0, .external_lex_state = 2},
  [181] = {.lex_state = 0, .external_lex_state = 2},
  [182] = {.lex_state = 0, .external_lex_state = 2},
  [183] = {.lex_state = 8, .external_lex_state = 2},
  [184] = {.lex_state = 8, .external_lex_state = 2},
  [185] = {.lex_state = 0, .external_lex_state = 2},
  [186] = {.lex_state = 0, .external_lex_state = 4},
  [187] = {.lex_state = 0, .external_lex_state = 5},
  [188] = {.lex_state = 0, .external_lex_state = 4},
  [189] = {.lex_state = 9, .external_lex_state = 2},
  [190] = {.lex_state = 9, .external_lex_state = 2},
  [191] = {.lex_state = 0, .external_lex_state = 2},
  [192] = {.lex_state = 0, .external_lex_state = 2},
  [193] = {.lex_state = 0, .external_lex_state = 2},
  [194] = {.lex_state = 0, .external_lex_state = 2},
  [195] = {.lex_state = 0, .external_lex_state = 2},
  [196] = {.lex_state = 0, .external_lex_state = 2},
  [197] = {.lex_state = 0, .external_lex_state = 2},
  [198] = {.lex_state = 0, .external_lex_state = 2},
  [199] = {.lex_state = 0, .external_lex_state = 2},
  [200] = {.lex_state = 0, .external_lex_state = 2},
  [201] = {.lex_state = 0, .external_lex_state = 2},
  [202] = {.lex_state = 0, .external_lex_state = 2},
  [203] = {.lex_state = 0, .external_lex_state = 2},
  [204] = {.lex_state = 0, .external_lex_state = 2},
  [205] = {.lex_state = 0, .external_lex_state = 2},
  [206] = {.lex_state = 0, .external_lex_state = 2},
  [207] = {.lex_state = 0, .external_lex_state = 2},
  [208] = {.lex_state = 0, .external_lex_state = 6},
  [209] = {.lex_state = 0, .external_lex_state = 2},
  [210] = {.lex_state = 0, .external_lex_state = 2},
  [211] = {.lex_state = 0, .external_lex_state = 2},
  [212] = {.lex_state = 0, .external_lex_state = 7},
  [213] = {.lex_state = 0, .external_lex_state = 2},
  [214] = {.lex_state = 57, .external_lex_state = 2},
  [215] = {.lex_state = 0, .external_lex_state = 2},
  [216] = {.lex_state = 0, .external_lex_state = 2},
  [217] = {.lex_state = 0, .external_lex_state = 2},
  [218] = {.lex_state = 0, .external_lex_state = 6},
  [219] = {.lex_state = 0, .external_lex_state = 2},
  [220] = {.lex_state = 0, .external_lex_state = 2},
  [221] = {.lex_state = 0, .external_lex_state = 2},
  [222] = {.lex_state = 0, .external_lex_state = 2},
  [223] = {.lex_state = 0, .external_lex_state = 2},
  [224] = {.lex_state = 0, .external_lex_state = 2},
  [225] = {.lex_state = 0, .external_lex_state = 2},
  [226] = {.lex_state = 0, .external_lex_state = 2},
  [227] = {.lex_state = 0, .external_lex_state = 2},
  [228] = {.lex_state = 0, .external_lex_state = 2},
  [229] = {.lex_state = 0, .external_lex_state = 2},
  [230] = {.lex_state = 0, .external_lex_state = 2},
  [231] = {(TSStateId)(-1)},
  [232] = {(TSStateId)(-1)},
  [233] = {(TSStateId)(-1)},
};

enum {
  ts_external_token__block_comment_start = 0,
  ts_external_token__block_comment_content = 1,
  ts_external_token__block_comment_end = 2,
  ts_external_token__string_start = 3,
  ts_external_token__string_content = 4,
  ts_external_token__string_end = 5,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__block_comment_start] = sym__block_comment_start,
  [ts_external_token__block_comment_content] = sym__block_comment_content,
  [ts_external_token__block_comment_end] = sym__block_comment_end,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token__string_end] = sym__string_end,
};

static const bool ts_external_scanner_states[8][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_comment_content] = true,
    [ts_external_token__block_comment_end] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [2] = {
    [ts_external_token__block_comment_start] = true,
  },
  [3] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__string_start] = true,
  },
  [4] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [5] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_comment_content] = true,
    [ts_external_token__block_comment_end] = true,
  },
  [6] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__string_end] = true,
  },
  [7] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_comment_end] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [sym_break_statement] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_repeat] = ACTIONS(1),
    [anon_sym_until] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_elseif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [sym_nil] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_TILDE_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(3),
    [sym__block_comment_start] = ACTIONS(5),
    [sym__block_comment_content] = ACTIONS(1),
    [sym__block_comment_end] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
  },
  [1] = {
    [sym_chunk] = STATE(219),
    [sym_statement] = STATE(134),
    [sym_return_statement] = STATE(213),
    [sym_empty_statement] = STATE(117),
    [sym_assignment_statement] = STATE(117),
    [sym__variable_assignment_varlist] = STATE(192),
    [sym_label_statement] = STATE(117),
    [sym_goto_statement] = STATE(117),
    [sym_do_statement] = STATE(117),
    [sym_while_statement] = STATE(117),
    [sym_repeat_statement] = STATE(117),
    [sym_if_statement] = STATE(117),
    [sym_for_statement] = STATE(117),
    [sym_declaration] = STATE(135),
    [sym_function_declaration] = STATE(136),
    [sym__local_function_declaration] = STATE(138),
    [sym_variable_declaration] = STATE(140),
    [sym__prefix_expression] = STATE(148),
    [sym_variable] = STATE(149),
    [sym_bracket_index_expression] = STATE(4),
    [sym_dot_index_expression] = STATE(4),
    [sym_function_call] = STATE(96),
    [sym_method_index_expression] = STATE(151),
    [sym_parenthesized_expression] = STATE(154),
    [sym_comment] = STATE(1),
    [aux_sym_chunk_repeat1] = STATE(50),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [sym_hash_bang_line] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_COLON_COLON] = ACTIONS(17),
    [sym_break_statement] = ACTIONS(19),
    [anon_sym_goto] = ACTIONS(21),
    [anon_sym_do] = ACTIONS(23),
    [anon_sym_while] = ACTIONS(25),
    [anon_sym_repeat] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_function] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_DASH_DASH] = ACTIONS(3),
    [sym__block_comment_start] = ACTIONS(5),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(2), 1,
      sym_comment,
    ACTIONS(39), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(41), 26,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [65] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(3), 1,
      sym_comment,
    ACTIONS(43), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(45), 26,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [130] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(4), 1,
      sym_comment,
    ACTIONS(47), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(49), 26,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [195] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(5), 1,
      sym_comment,
    ACTIONS(51), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(53), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [259] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(6), 1,
      sym_comment,
    ACTIONS(55), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(57), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [323] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(7), 1,
      sym_comment,
    ACTIONS(59), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(61), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [387] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(8), 1,
      sym_comment,
    ACTIONS(63), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(65), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [451] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(9), 1,
      sym_comment,
    ACTIONS(67), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(69), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [515] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(10), 1,
      sym_comment,
    ACTIONS(71), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(73), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [579] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(11), 1,
      sym_comment,
    ACTIONS(75), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(77), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [643] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(12), 1,
      sym_comment,
    ACTIONS(79), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(81), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [707] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(13), 1,
      sym_comment,
    ACTIONS(83), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(85), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [771] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(14), 1,
      sym_comment,
    ACTIONS(91), 2,
      anon_sym_DOT,
      anon_sym_COLON,
    ACTIONS(93), 4,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(87), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(89), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [839] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(15), 1,
      sym_comment,
    ACTIONS(95), 25,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(97), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [903] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(16), 1,
      sym_comment,
    ACTIONS(75), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(77), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [962] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(17), 1,
      sym_comment,
    ACTIONS(99), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(101), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [1021] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(107), 1,
      anon_sym_and,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    STATE(18), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(103), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(105), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      sym_identifier,
  [1106] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(131), 1,
      anon_sym_CARET,
    STATE(19), 1,
      sym_comment,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(103), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DOT_DOT,
    ACTIONS(105), 22,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      sym_identifier,
  [1171] = 17,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    STATE(20), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(103), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(105), 18,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
  [1254] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    STATE(21), 1,
      sym_comment,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(103), 12,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(105), 20,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      sym_identifier,
  [1333] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(131), 1,
      anon_sym_CARET,
    STATE(22), 1,
      sym_comment,
    ACTIONS(133), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    ACTIONS(135), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [1394] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(131), 1,
      anon_sym_CARET,
    STATE(23), 1,
      sym_comment,
    ACTIONS(103), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    ACTIONS(105), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [1455] = 11,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    STATE(24), 1,
      sym_comment,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(103), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(105), 21,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      sym_identifier,
  [1526] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(131), 1,
      anon_sym_CARET,
    STATE(25), 1,
      sym_comment,
    ACTIONS(103), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    ACTIONS(105), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [1587] = 14,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    STATE(26), 1,
      sym_comment,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(103), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
    ACTIONS(105), 20,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      sym_identifier,
  [1664] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(27), 1,
      sym_comment,
    ACTIONS(71), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(73), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [1723] = 13,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    STATE(28), 1,
      sym_comment,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(103), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
    ACTIONS(105), 21,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      sym_identifier,
  [1798] = 12,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    STATE(29), 1,
      sym_comment,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(103), 14,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(105), 21,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      sym_identifier,
  [1871] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(30), 1,
      sym_comment,
    ACTIONS(137), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(139), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [1930] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(31), 1,
      sym_comment,
    ACTIONS(87), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(89), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [1989] = 39,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_end,
    ACTIONS(143), 1,
      anon_sym_elseif,
    ACTIONS(145), 1,
      anon_sym_else,
    STATE(32), 1,
      sym_comment,
    STATE(40), 1,
      aux_sym_chunk_repeat1,
    STATE(96), 1,
      sym_function_call,
    STATE(134), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(136), 1,
      sym_function_declaration,
    STATE(138), 1,
      sym__local_function_declaration,
    STATE(140), 1,
      sym_variable_declaration,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(149), 1,
      sym_variable,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(153), 1,
      aux_sym_if_statement_repeat1,
    STATE(154), 1,
      sym_parenthesized_expression,
    STATE(155), 1,
      sym__block,
    STATE(165), 1,
      sym_return_statement,
    STATE(179), 1,
      sym_elseif_statement,
    STATE(192), 1,
      sym__variable_assignment_varlist,
    STATE(201), 1,
      sym_else_statement,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(117), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [2116] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(33), 1,
      sym_comment,
    ACTIONS(59), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(61), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [2175] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(34), 1,
      sym_comment,
    ACTIONS(147), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(149), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [2234] = 11,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    STATE(35), 1,
      sym_comment,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(103), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(105), 21,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      sym_identifier,
  [2305] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(36), 1,
      sym_comment,
    ACTIONS(67), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(69), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
  [2364] = 31,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(151), 1,
      ts_builtin_sym_end,
    ACTIONS(153), 1,
      sym_identifier,
    ACTIONS(158), 1,
      anon_sym_SEMI,
    ACTIONS(161), 1,
      anon_sym_COLON_COLON,
    ACTIONS(164), 1,
      sym_break_statement,
    ACTIONS(167), 1,
      anon_sym_goto,
    ACTIONS(170), 1,
      anon_sym_do,
    ACTIONS(173), 1,
      anon_sym_while,
    ACTIONS(176), 1,
      anon_sym_repeat,
    ACTIONS(179), 1,
      anon_sym_if,
    ACTIONS(182), 1,
      anon_sym_for,
    ACTIONS(185), 1,
      anon_sym_function,
    ACTIONS(188), 1,
      anon_sym_local,
    ACTIONS(191), 1,
      anon_sym_LPAREN,
    STATE(96), 1,
      sym_function_call,
    STATE(134), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(136), 1,
      sym_function_declaration,
    STATE(138), 1,
      sym__local_function_declaration,
    STATE(140), 1,
      sym_variable_declaration,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(149), 1,
      sym_variable,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(154), 1,
      sym_parenthesized_expression,
    STATE(192), 1,
      sym__variable_assignment_varlist,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(37), 2,
      sym_comment,
      aux_sym_chunk_repeat1,
    ACTIONS(156), 5,
      anon_sym_return,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_else,
    STATE(117), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [2472] = 21,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(107), 1,
      anon_sym_and,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(198), 1,
      anon_sym_COMMA,
    ACTIONS(200), 1,
      anon_sym_or,
    STATE(38), 1,
      sym_comment,
    STATE(112), 1,
      aux_sym__variable_assignment_explist_repeat1,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(194), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(196), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [2560] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    STATE(39), 1,
      sym_comment,
    STATE(40), 1,
      aux_sym_chunk_repeat1,
    STATE(96), 1,
      sym_function_call,
    STATE(134), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(136), 1,
      sym_function_declaration,
    STATE(138), 1,
      sym__local_function_declaration,
    STATE(140), 1,
      sym_variable_declaration,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(149), 1,
      sym_variable,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(154), 1,
      sym_parenthesized_expression,
    STATE(165), 1,
      sym_return_statement,
    STATE(173), 1,
      sym__block,
    STATE(192), 1,
      sym__variable_assignment_varlist,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(202), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
    STATE(117), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [2674] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    STATE(37), 1,
      aux_sym_chunk_repeat1,
    STATE(40), 1,
      sym_comment,
    STATE(96), 1,
      sym_function_call,
    STATE(134), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(136), 1,
      sym_function_declaration,
    STATE(138), 1,
      sym__local_function_declaration,
    STATE(140), 1,
      sym_variable_declaration,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(149), 1,
      sym_variable,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(154), 1,
      sym_parenthesized_expression,
    STATE(169), 1,
      sym_return_statement,
    STATE(192), 1,
      sym__variable_assignment_varlist,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(204), 4,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_else,
    STATE(117), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [2786] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(107), 1,
      anon_sym_and,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(200), 1,
      anon_sym_or,
    STATE(41), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(206), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(208), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [2869] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(210), 1,
      anon_sym_end,
    STATE(40), 1,
      aux_sym_chunk_repeat1,
    STATE(42), 1,
      sym_comment,
    STATE(96), 1,
      sym_function_call,
    STATE(134), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(136), 1,
      sym_function_declaration,
    STATE(138), 1,
      sym__local_function_declaration,
    STATE(140), 1,
      sym_variable_declaration,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(149), 1,
      sym_variable,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(154), 1,
      sym_parenthesized_expression,
    STATE(165), 1,
      sym_return_statement,
    STATE(192), 1,
      sym__variable_assignment_varlist,
    STATE(193), 1,
      sym__block,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(117), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [2981] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(212), 1,
      anon_sym_end,
    STATE(40), 1,
      aux_sym_chunk_repeat1,
    STATE(43), 1,
      sym_comment,
    STATE(96), 1,
      sym_function_call,
    STATE(134), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(136), 1,
      sym_function_declaration,
    STATE(138), 1,
      sym__local_function_declaration,
    STATE(140), 1,
      sym_variable_declaration,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(149), 1,
      sym_variable,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(154), 1,
      sym_parenthesized_expression,
    STATE(165), 1,
      sym_return_statement,
    STATE(192), 1,
      sym__variable_assignment_varlist,
    STATE(205), 1,
      sym__block,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(117), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [3093] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(214), 1,
      anon_sym_end,
    STATE(40), 1,
      aux_sym_chunk_repeat1,
    STATE(44), 1,
      sym_comment,
    STATE(96), 1,
      sym_function_call,
    STATE(134), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(136), 1,
      sym_function_declaration,
    STATE(138), 1,
      sym__local_function_declaration,
    STATE(140), 1,
      sym_variable_declaration,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(149), 1,
      sym_variable,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(154), 1,
      sym_parenthesized_expression,
    STATE(165), 1,
      sym_return_statement,
    STATE(192), 1,
      sym__variable_assignment_varlist,
    STATE(198), 1,
      sym__block,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(117), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [3205] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(107), 1,
      anon_sym_and,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(200), 1,
      anon_sym_or,
    STATE(45), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(216), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(218), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [3287] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(220), 1,
      anon_sym_end,
    STATE(40), 1,
      aux_sym_chunk_repeat1,
    STATE(46), 1,
      sym_comment,
    STATE(96), 1,
      sym_function_call,
    STATE(134), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(136), 1,
      sym_function_declaration,
    STATE(138), 1,
      sym__local_function_declaration,
    STATE(140), 1,
      sym_variable_declaration,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(149), 1,
      sym_variable,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(154), 1,
      sym_parenthesized_expression,
    STATE(165), 1,
      sym_return_statement,
    STATE(192), 1,
      sym__variable_assignment_varlist,
    STATE(229), 1,
      sym__block,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(117), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [3399] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(222), 1,
      anon_sym_end,
    STATE(40), 1,
      aux_sym_chunk_repeat1,
    STATE(47), 1,
      sym_comment,
    STATE(96), 1,
      sym_function_call,
    STATE(134), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(136), 1,
      sym_function_declaration,
    STATE(138), 1,
      sym__local_function_declaration,
    STATE(140), 1,
      sym_variable_declaration,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(149), 1,
      sym_variable,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(154), 1,
      sym_parenthesized_expression,
    STATE(165), 1,
      sym_return_statement,
    STATE(192), 1,
      sym__variable_assignment_varlist,
    STATE(215), 1,
      sym__block,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(117), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [3511] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(107), 1,
      anon_sym_and,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(200), 1,
      anon_sym_or,
    STATE(48), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(224), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(226), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [3593] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(228), 1,
      anon_sym_until,
    STATE(40), 1,
      aux_sym_chunk_repeat1,
    STATE(49), 1,
      sym_comment,
    STATE(96), 1,
      sym_function_call,
    STATE(134), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(136), 1,
      sym_function_declaration,
    STATE(138), 1,
      sym__local_function_declaration,
    STATE(140), 1,
      sym_variable_declaration,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(149), 1,
      sym_variable,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(154), 1,
      sym_parenthesized_expression,
    STATE(165), 1,
      sym_return_statement,
    STATE(192), 1,
      sym__variable_assignment_varlist,
    STATE(194), 1,
      sym__block,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(117), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [3705] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(230), 1,
      ts_builtin_sym_end,
    STATE(37), 1,
      aux_sym_chunk_repeat1,
    STATE(50), 1,
      sym_comment,
    STATE(96), 1,
      sym_function_call,
    STATE(134), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(136), 1,
      sym_function_declaration,
    STATE(138), 1,
      sym__local_function_declaration,
    STATE(140), 1,
      sym_variable_declaration,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(149), 1,
      sym_variable,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(154), 1,
      sym_parenthesized_expression,
    STATE(192), 1,
      sym__variable_assignment_varlist,
    STATE(211), 1,
      sym_return_statement,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(117), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [3814] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      ts_builtin_sym_end,
    STATE(37), 1,
      aux_sym_chunk_repeat1,
    STATE(51), 1,
      sym_comment,
    STATE(96), 1,
      sym_function_call,
    STATE(134), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(136), 1,
      sym_function_declaration,
    STATE(138), 1,
      sym__local_function_declaration,
    STATE(140), 1,
      sym_variable_declaration,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(149), 1,
      sym_variable,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(154), 1,
      sym_parenthesized_expression,
    STATE(192), 1,
      sym__variable_assignment_varlist,
    STATE(216), 1,
      sym_return_statement,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(117), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [3923] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(17), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19), 1,
      sym_break_statement,
    ACTIONS(21), 1,
      anon_sym_goto,
    ACTIONS(23), 1,
      anon_sym_do,
    ACTIONS(25), 1,
      anon_sym_while,
    ACTIONS(27), 1,
      anon_sym_repeat,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_for,
    ACTIONS(33), 1,
      anon_sym_function,
    ACTIONS(35), 1,
      anon_sym_local,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(230), 1,
      ts_builtin_sym_end,
    STATE(51), 1,
      aux_sym_chunk_repeat1,
    STATE(52), 1,
      sym_comment,
    STATE(96), 1,
      sym_function_call,
    STATE(134), 1,
      sym_statement,
    STATE(135), 1,
      sym_declaration,
    STATE(136), 1,
      sym_function_declaration,
    STATE(138), 1,
      sym__local_function_declaration,
    STATE(140), 1,
      sym_variable_declaration,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(149), 1,
      sym_variable,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(154), 1,
      sym_parenthesized_expression,
    STATE(192), 1,
      sym__variable_assignment_varlist,
    STATE(211), 1,
      sym_return_statement,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(117), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_label_statement,
      sym_goto_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
  [4032] = 22,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(234), 1,
      ts_builtin_sym_end,
    ACTIONS(236), 1,
      anon_sym_SEMI,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(53), 1,
      sym_comment,
    STATE(58), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(156), 1,
      sym__expression_list,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    ACTIONS(238), 4,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_else,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4114] = 22,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    ACTIONS(254), 1,
      sym_identifier,
    ACTIONS(256), 1,
      anon_sym_LBRACK,
    ACTIONS(258), 1,
      anon_sym_RBRACE,
    STATE(54), 1,
      sym_comment,
    STATE(94), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(160), 1,
      sym_field,
    STATE(206), 1,
      sym__field_list,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4193] = 22,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    ACTIONS(254), 1,
      sym_identifier,
    ACTIONS(256), 1,
      anon_sym_LBRACK,
    ACTIONS(260), 1,
      anon_sym_RBRACE,
    STATE(55), 1,
      sym_comment,
    STATE(94), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(160), 1,
      sym_field,
    STATE(223), 1,
      sym__field_list,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4272] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(262), 1,
      anon_sym_EQ,
    STATE(56), 1,
      sym_comment,
    ACTIONS(49), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(47), 24,
      sym__string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
  [4319] = 21,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    ACTIONS(254), 1,
      sym_identifier,
    ACTIONS(256), 1,
      anon_sym_LBRACK,
    ACTIONS(264), 1,
      anon_sym_RBRACE,
    STATE(57), 1,
      sym_comment,
    STATE(94), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(181), 1,
      sym_field,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4395] = 21,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(268), 1,
      anon_sym_COMMA,
    ACTIONS(270), 1,
      anon_sym_else,
    ACTIONS(272), 1,
      anon_sym_or,
    ACTIONS(274), 1,
      anon_sym_and,
    STATE(58), 1,
      sym_comment,
    STATE(147), 1,
      aux_sym__expression_list_repeat1,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(266), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [4471] = 21,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    ACTIONS(254), 1,
      sym_identifier,
    ACTIONS(256), 1,
      anon_sym_LBRACK,
    ACTIONS(276), 1,
      anon_sym_RBRACE,
    STATE(59), 1,
      sym_comment,
    STATE(94), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(181), 1,
      sym_field,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4547] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(272), 1,
      anon_sym_or,
    ACTIONS(274), 1,
      anon_sym_and,
    ACTIONS(280), 1,
      anon_sym_else,
    STATE(60), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(278), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_RPAREN,
  [4619] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    ACTIONS(254), 1,
      sym_identifier,
    ACTIONS(256), 1,
      anon_sym_LBRACK,
    STATE(61), 1,
      sym_comment,
    STATE(94), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(181), 1,
      sym_field,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4692] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(38), 1,
      sym_expression,
    STATE(62), 1,
      sym_comment,
    STATE(126), 1,
      sym__variable_assignment_explist,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4762] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(58), 1,
      sym_expression,
    STATE(63), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(224), 1,
      sym__expression_list,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4832] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(38), 1,
      sym_expression,
    STATE(64), 1,
      sym_comment,
    STATE(141), 1,
      sym__variable_assignment_explist,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4902] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    ACTIONS(282), 1,
      anon_sym_RPAREN,
    STATE(65), 1,
      sym_comment,
    STATE(97), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [4972] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(66), 1,
      sym_comment,
    STATE(107), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5039] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(28), 1,
      sym_expression,
    STATE(67), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5106] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(45), 1,
      sym_expression,
    STATE(68), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5173] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(69), 1,
      sym_comment,
    STATE(105), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5240] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(70), 1,
      sym_comment,
    STATE(103), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5307] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(71), 1,
      sym_comment,
    STATE(106), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5374] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(72), 1,
      sym_comment,
    STATE(95), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5441] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(25), 1,
      sym_expression,
    STATE(73), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5508] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(74), 1,
      sym_comment,
    STATE(104), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5575] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(24), 1,
      sym_expression,
    STATE(75), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5642] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(23), 1,
      sym_expression,
    STATE(76), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5709] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(19), 1,
      sym_expression,
    STATE(77), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5776] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(41), 1,
      sym_expression,
    STATE(78), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5843] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(35), 1,
      sym_expression,
    STATE(79), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5910] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(29), 1,
      sym_expression,
    STATE(80), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [5977] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(81), 1,
      sym_comment,
    STATE(108), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6044] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(26), 1,
      sym_expression,
    STATE(82), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6111] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(21), 1,
      sym_expression,
    STATE(83), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6178] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(20), 1,
      sym_expression,
    STATE(84), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6245] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(85), 1,
      sym_comment,
    STATE(102), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6312] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(18), 1,
      sym_expression,
    STATE(86), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6379] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(22), 1,
      sym_expression,
    STATE(87), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6446] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(88), 1,
      sym_comment,
    STATE(100), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6513] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(60), 1,
      sym_expression,
    STATE(89), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6580] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(48), 1,
      sym_expression,
    STATE(90), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6647] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(91), 1,
      sym_comment,
    STATE(98), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6714] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(240), 1,
      anon_sym_function,
    ACTIONS(246), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym__string_start,
    STATE(92), 1,
      sym_comment,
    STATE(109), 1,
      sym_expression,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(151), 1,
      sym_method_index_expression,
    ACTIONS(244), 2,
      sym_number,
      sym_vararg_expression,
    ACTIONS(248), 2,
      anon_sym_TILDE,
      anon_sym_POUND,
    ACTIONS(250), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(242), 3,
      sym_nil,
      sym_false,
      sym_true,
    STATE(14), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(31), 5,
      sym_string,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
  [6781] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(288), 1,
      anon_sym_COMMA,
    STATE(93), 2,
      sym_comment,
      aux_sym__name_list_repeat1,
    ACTIONS(284), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    ACTIONS(286), 16,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [6821] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(272), 1,
      anon_sym_or,
    ACTIONS(274), 1,
      anon_sym_and,
    STATE(94), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(291), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [6885] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(272), 1,
      anon_sym_or,
    ACTIONS(274), 1,
      anon_sym_and,
    STATE(95), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(293), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [6949] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(91), 1,
      anon_sym_COLON,
    STATE(96), 1,
      sym_comment,
    ACTIONS(295), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
    ACTIONS(93), 5,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(297), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [6991] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(268), 1,
      anon_sym_COMMA,
    ACTIONS(272), 1,
      anon_sym_or,
    ACTIONS(274), 1,
      anon_sym_and,
    ACTIONS(299), 1,
      anon_sym_RPAREN,
    STATE(97), 1,
      sym_comment,
    STATE(180), 1,
      aux_sym__expression_list_repeat1,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7059] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(272), 1,
      anon_sym_or,
    ACTIONS(274), 1,
      anon_sym_and,
    STATE(98), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(301), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7123] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(99), 1,
      sym_comment,
    ACTIONS(303), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    ACTIONS(305), 16,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [7160] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(272), 1,
      anon_sym_or,
    ACTIONS(274), 1,
      anon_sym_and,
    ACTIONS(307), 1,
      anon_sym_COMMA,
    ACTIONS(309), 1,
      anon_sym_do,
    STATE(100), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7225] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(315), 1,
      anon_sym_COMMA,
    STATE(93), 1,
      aux_sym__name_list_repeat1,
    STATE(101), 1,
      sym_comment,
    ACTIONS(311), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(313), 16,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_in,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [7266] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(272), 1,
      anon_sym_or,
    ACTIONS(274), 1,
      anon_sym_and,
    ACTIONS(317), 1,
      anon_sym_then,
    STATE(102), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7328] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(272), 1,
      anon_sym_or,
    ACTIONS(274), 1,
      anon_sym_and,
    ACTIONS(319), 1,
      anon_sym_do,
    STATE(103), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7390] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(272), 1,
      anon_sym_or,
    ACTIONS(274), 1,
      anon_sym_and,
    ACTIONS(321), 1,
      anon_sym_RBRACK,
    STATE(104), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7452] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(272), 1,
      anon_sym_or,
    ACTIONS(274), 1,
      anon_sym_and,
    ACTIONS(323), 1,
      anon_sym_then,
    STATE(105), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7514] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(272), 1,
      anon_sym_or,
    ACTIONS(274), 1,
      anon_sym_and,
    ACTIONS(325), 1,
      anon_sym_COMMA,
    STATE(106), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7576] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(272), 1,
      anon_sym_or,
    ACTIONS(274), 1,
      anon_sym_and,
    ACTIONS(327), 1,
      anon_sym_RBRACK,
    STATE(107), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7638] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(272), 1,
      anon_sym_or,
    ACTIONS(274), 1,
      anon_sym_and,
    ACTIONS(329), 1,
      anon_sym_do,
    STATE(108), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7700] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(113), 1,
      anon_sym_PIPE,
    ACTIONS(115), 1,
      anon_sym_TILDE,
    ACTIONS(117), 1,
      anon_sym_AMP,
    ACTIONS(121), 1,
      anon_sym_PLUS,
    ACTIONS(123), 1,
      anon_sym_DASH,
    ACTIONS(127), 1,
      anon_sym_SLASH,
    ACTIONS(129), 1,
      anon_sym_DOT_DOT,
    ACTIONS(131), 1,
      anon_sym_CARET,
    ACTIONS(272), 1,
      anon_sym_or,
    ACTIONS(274), 1,
      anon_sym_and,
    ACTIONS(331), 1,
      anon_sym_RPAREN,
    STATE(109), 1,
      sym_comment,
    ACTIONS(109), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(119), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(125), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(111), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [7762] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(315), 1,
      anon_sym_COMMA,
    STATE(101), 1,
      aux_sym__name_list_repeat1,
    STATE(110), 1,
      sym_comment,
    ACTIONS(333), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(335), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [7802] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(341), 1,
      anon_sym_COMMA,
    STATE(111), 2,
      sym_comment,
      aux_sym__variable_assignment_explist_repeat1,
    ACTIONS(337), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(339), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [7839] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(198), 1,
      anon_sym_COMMA,
    STATE(111), 1,
      aux_sym__variable_assignment_explist_repeat1,
    STATE(112), 1,
      sym_comment,
    ACTIONS(344), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(346), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [7878] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(352), 1,
      anon_sym_EQ,
    STATE(113), 1,
      sym_comment,
    ACTIONS(348), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(350), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [7914] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(114), 1,
      sym_comment,
    ACTIONS(354), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(356), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [7947] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(115), 1,
      sym_comment,
    ACTIONS(358), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(360), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [7980] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(116), 1,
      sym_comment,
    ACTIONS(362), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(364), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8013] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(117), 1,
      sym_comment,
    ACTIONS(295), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(297), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8046] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(118), 1,
      sym_comment,
    ACTIONS(366), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(368), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8079] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(119), 1,
      sym_comment,
    ACTIONS(370), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(372), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8112] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(120), 1,
      sym_comment,
    ACTIONS(374), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(376), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8145] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(121), 1,
      sym_comment,
    ACTIONS(378), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(380), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8178] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(122), 1,
      sym_comment,
    ACTIONS(382), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(384), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8211] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(123), 1,
      sym_comment,
    ACTIONS(386), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(388), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8244] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(124), 1,
      sym_comment,
    ACTIONS(390), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(392), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8277] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(125), 1,
      sym_comment,
    ACTIONS(394), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(396), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8310] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(126), 1,
      sym_comment,
    ACTIONS(398), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(400), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8343] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(127), 1,
      sym_comment,
    ACTIONS(402), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(404), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8376] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(128), 1,
      sym_comment,
    ACTIONS(406), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(408), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8409] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(129), 1,
      sym_comment,
    ACTIONS(410), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(412), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8442] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(130), 1,
      sym_comment,
    ACTIONS(414), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(416), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8475] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(131), 1,
      sym_comment,
    ACTIONS(418), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(420), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8508] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(132), 1,
      sym_comment,
    ACTIONS(422), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(424), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8541] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(133), 1,
      sym_comment,
    ACTIONS(426), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(428), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8574] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(134), 1,
      sym_comment,
    ACTIONS(430), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(432), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8607] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(135), 1,
      sym_comment,
    ACTIONS(434), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(436), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8640] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(136), 1,
      sym_comment,
    ACTIONS(438), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(440), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8673] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(137), 1,
      sym_comment,
    ACTIONS(442), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(444), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8706] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(138), 1,
      sym_comment,
    ACTIONS(446), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(448), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8739] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(139), 1,
      sym_comment,
    ACTIONS(450), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(452), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8772] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(140), 1,
      sym_comment,
    ACTIONS(454), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(456), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8805] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(141), 1,
      sym_comment,
    ACTIONS(458), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(460), 15,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8838] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(142), 1,
      sym_comment,
    ACTIONS(462), 7,
      anon_sym_function,
      sym_nil,
      sym_false,
      sym_true,
      anon_sym_DASH,
      anon_sym_not,
      sym_identifier,
    ACTIONS(464), 9,
      sym__string_start,
      sym_number,
      sym_vararg_expression,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_POUND,
  [8868] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(143), 1,
      sym_comment,
    ACTIONS(468), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(466), 12,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_if,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8897] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(144), 1,
      sym_comment,
    ACTIONS(472), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
    ACTIONS(470), 12,
      anon_sym_return,
      sym_break_statement,
      anon_sym_goto,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_if,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
  [8926] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(280), 1,
      anon_sym_else,
    ACTIONS(474), 1,
      anon_sym_COMMA,
    STATE(145), 2,
      sym_comment,
      aux_sym__expression_list_repeat1,
    ACTIONS(278), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_RPAREN,
  [8952] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(37), 1,
      anon_sym_LPAREN,
    ACTIONS(477), 1,
      sym_identifier,
    STATE(146), 1,
      sym_comment,
    STATE(148), 1,
      sym__prefix_expression,
    STATE(150), 1,
      sym_variable,
    STATE(151), 1,
      sym_method_index_expression,
    STATE(4), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(154), 2,
      sym_function_call,
      sym_parenthesized_expression,
  [8985] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(268), 1,
      anon_sym_COMMA,
    ACTIONS(481), 1,
      anon_sym_else,
    STATE(145), 1,
      aux_sym__expression_list_repeat1,
    STATE(147), 1,
      sym_comment,
    ACTIONS(479), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [9012] = 11,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(483), 1,
      anon_sym_DOT,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(487), 1,
      anon_sym_LPAREN,
    ACTIONS(489), 1,
      anon_sym_LBRACK,
    ACTIONS(491), 1,
      anon_sym_LBRACE,
    ACTIONS(493), 1,
      sym__string_start,
    STATE(12), 1,
      sym_arguments,
    STATE(148), 1,
      sym_comment,
    STATE(13), 2,
      sym_string,
      sym_table_constructor,
  [9047] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(495), 1,
      anon_sym_EQ,
    ACTIONS(497), 1,
      anon_sym_COMMA,
    STATE(149), 1,
      sym_comment,
    STATE(178), 1,
      aux_sym__variable_assignment_varlist_repeat1,
    ACTIONS(93), 6,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [9074] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(150), 1,
      sym_comment,
    ACTIONS(499), 2,
      anon_sym_EQ,
      anon_sym_COMMA,
    ACTIONS(93), 6,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [9096] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(487), 1,
      anon_sym_LPAREN,
    ACTIONS(491), 1,
      anon_sym_LBRACE,
    ACTIONS(493), 1,
      sym__string_start,
    STATE(12), 1,
      sym_arguments,
    STATE(151), 1,
      sym_comment,
    STATE(13), 2,
      sym_string,
      sym_table_constructor,
  [9122] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(145), 1,
      anon_sym_else,
    ACTIONS(501), 1,
      anon_sym_end,
    ACTIONS(503), 1,
      anon_sym_elseif,
    STATE(152), 1,
      sym_comment,
    STATE(159), 1,
      aux_sym_if_statement_repeat1,
    STATE(179), 1,
      sym_elseif_statement,
    STATE(217), 1,
      sym_else_statement,
  [9150] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(145), 1,
      anon_sym_else,
    ACTIONS(503), 1,
      anon_sym_elseif,
    ACTIONS(505), 1,
      anon_sym_end,
    STATE(153), 1,
      sym_comment,
    STATE(159), 1,
      aux_sym_if_statement_repeat1,
    STATE(179), 1,
      sym_elseif_statement,
    STATE(203), 1,
      sym_else_statement,
  [9178] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(154), 1,
      sym_comment,
    ACTIONS(93), 6,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [9196] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(145), 1,
      anon_sym_else,
    ACTIONS(503), 1,
      anon_sym_elseif,
    ACTIONS(507), 1,
      anon_sym_end,
    STATE(152), 1,
      aux_sym_if_statement_repeat1,
    STATE(155), 1,
      sym_comment,
    STATE(179), 1,
      sym_elseif_statement,
    STATE(199), 1,
      sym_else_statement,
  [9224] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(511), 1,
      anon_sym_SEMI,
    ACTIONS(513), 1,
      anon_sym_else,
    STATE(156), 1,
      sym_comment,
    ACTIONS(509), 4,
      ts_builtin_sym_end,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [9246] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(518), 1,
      anon_sym_RBRACE,
    STATE(61), 1,
      sym__field_sep,
    ACTIONS(515), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(157), 2,
      sym_comment,
      aux_sym__field_list_repeat1,
  [9267] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(264), 1,
      anon_sym_RBRACE,
    STATE(59), 1,
      sym__field_sep,
    STATE(157), 1,
      aux_sym__field_list_repeat1,
    STATE(158), 1,
      sym_comment,
    ACTIONS(520), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [9290] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(522), 1,
      anon_sym_end,
    ACTIONS(524), 1,
      anon_sym_elseif,
    ACTIONS(527), 1,
      anon_sym_else,
    STATE(179), 1,
      sym_elseif_statement,
    STATE(159), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [9313] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(529), 1,
      anon_sym_RBRACE,
    STATE(57), 1,
      sym__field_sep,
    STATE(158), 1,
      aux_sym__field_list_repeat1,
    STATE(160), 1,
      sym_comment,
    ACTIONS(520), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [9336] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(533), 1,
      anon_sym_else,
    STATE(161), 1,
      sym_comment,
    ACTIONS(531), 4,
      ts_builtin_sym_end,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [9355] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(535), 1,
      sym_identifier,
    STATE(162), 1,
      sym_comment,
    STATE(171), 1,
      sym__function_name_prefix_expression,
    STATE(183), 1,
      sym__function_name_dot_index_expression,
    STATE(185), 1,
      sym__function_name,
    STATE(200), 1,
      sym__function_name_method_index_expression,
  [9380] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(513), 1,
      anon_sym_else,
    STATE(163), 1,
      sym_comment,
    ACTIONS(509), 4,
      ts_builtin_sym_end,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [9399] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(315), 1,
      anon_sym_COMMA,
    ACTIONS(333), 1,
      anon_sym_in,
    ACTIONS(537), 1,
      anon_sym_EQ,
    STATE(101), 1,
      aux_sym__name_list_repeat1,
    STATE(164), 1,
      sym_comment,
  [9421] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(204), 1,
      anon_sym_else,
    STATE(165), 1,
      sym_comment,
    ACTIONS(539), 3,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [9439] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(541), 1,
      sym_identifier,
    STATE(166), 1,
      sym_comment,
    STATE(197), 1,
      sym__name_list,
    STATE(196), 2,
      sym_for_generic_clause,
      sym_for_numeric_clause,
  [9459] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(543), 1,
      sym_identifier,
    ACTIONS(545), 1,
      sym_vararg_expression,
    ACTIONS(547), 1,
      anon_sym_RPAREN,
    STATE(167), 1,
      sym_comment,
    STATE(207), 1,
      sym__parameter_list,
  [9481] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(549), 1,
      sym_identifier,
    ACTIONS(551), 1,
      anon_sym_function,
    STATE(113), 1,
      sym__name_list,
    STATE(129), 1,
      sym__local_variable_assignment,
    STATE(168), 1,
      sym_comment,
  [9503] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(555), 1,
      anon_sym_else,
    STATE(169), 1,
      sym_comment,
    ACTIONS(553), 3,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [9521] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(557), 1,
      anon_sym_LPAREN,
    STATE(30), 1,
      sym__function_body,
    STATE(43), 1,
      sym_parameters,
    STATE(170), 1,
      sym_comment,
  [9540] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(559), 1,
      anon_sym_DOT,
    ACTIONS(561), 1,
      anon_sym_COLON,
    ACTIONS(563), 1,
      anon_sym_LPAREN,
    STATE(171), 1,
      sym_comment,
  [9559] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(557), 1,
      anon_sym_LPAREN,
    STATE(43), 1,
      sym_parameters,
    STATE(127), 1,
      sym__function_body,
    STATE(172), 1,
      sym_comment,
  [9578] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(567), 1,
      anon_sym_else,
    STATE(173), 1,
      sym_comment,
    ACTIONS(565), 2,
      anon_sym_end,
      anon_sym_elseif,
  [9595] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(174), 1,
      sym_comment,
    ACTIONS(569), 3,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [9610] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(175), 1,
      sym_comment,
    ACTIONS(571), 3,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [9625] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(573), 1,
      anon_sym_EQ,
    ACTIONS(575), 1,
      anon_sym_COMMA,
    STATE(176), 2,
      sym_comment,
      aux_sym__variable_assignment_varlist_repeat1,
  [9642] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(578), 1,
      anon_sym_COMMA,
    ACTIONS(580), 1,
      anon_sym_RPAREN,
    STATE(177), 1,
      sym_comment,
    STATE(182), 1,
      aux_sym__name_list_repeat1,
  [9661] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(497), 1,
      anon_sym_COMMA,
    ACTIONS(582), 1,
      anon_sym_EQ,
    STATE(176), 1,
      aux_sym__variable_assignment_varlist_repeat1,
    STATE(178), 1,
      sym_comment,
  [9680] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(586), 1,
      anon_sym_else,
    STATE(179), 1,
      sym_comment,
    ACTIONS(584), 2,
      anon_sym_end,
      anon_sym_elseif,
  [9697] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(268), 1,
      anon_sym_COMMA,
    ACTIONS(588), 1,
      anon_sym_RPAREN,
    STATE(145), 1,
      aux_sym__expression_list_repeat1,
    STATE(180), 1,
      sym_comment,
  [9716] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(181), 1,
      sym_comment,
    ACTIONS(518), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [9731] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(590), 1,
      anon_sym_COMMA,
    ACTIONS(592), 1,
      anon_sym_RPAREN,
    STATE(93), 1,
      aux_sym__name_list_repeat1,
    STATE(182), 1,
      sym_comment,
  [9750] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(183), 1,
      sym_comment,
    ACTIONS(594), 3,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [9765] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(184), 1,
      sym_comment,
    ACTIONS(596), 3,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LPAREN,
  [9780] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(557), 1,
      anon_sym_LPAREN,
    STATE(43), 1,
      sym_parameters,
    STATE(120), 1,
      sym__function_body,
    STATE(185), 1,
      sym_comment,
  [9799] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(598), 1,
      sym__string_content,
    ACTIONS(600), 1,
      sym__string_end,
    STATE(186), 1,
      sym_comment,
  [9815] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(602), 1,
      sym__block_comment_content,
    ACTIONS(604), 1,
      sym__block_comment_end,
    STATE(187), 1,
      sym_comment,
  [9831] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(606), 1,
      sym__string_content,
    ACTIONS(608), 1,
      sym__string_end,
    STATE(188), 1,
      sym_comment,
  [9847] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(610), 1,
      sym_identifier,
    ACTIONS(612), 1,
      sym_vararg_expression,
    STATE(189), 1,
      sym_comment,
  [9863] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(610), 1,
      sym_identifier,
    ACTIONS(614), 1,
      sym_vararg_expression,
    STATE(190), 1,
      sym_comment,
  [9879] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(616), 1,
      sym_identifier,
    STATE(191), 1,
      sym_comment,
  [9892] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(618), 1,
      anon_sym_EQ,
    STATE(192), 1,
      sym_comment,
  [9905] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(620), 1,
      anon_sym_end,
    STATE(193), 1,
      sym_comment,
  [9918] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(622), 1,
      anon_sym_until,
    STATE(194), 1,
      sym_comment,
  [9931] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(624), 1,
      anon_sym_EQ,
    STATE(195), 1,
      sym_comment,
  [9944] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(626), 1,
      anon_sym_do,
    STATE(196), 1,
      sym_comment,
  [9957] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(628), 1,
      anon_sym_in,
    STATE(197), 1,
      sym_comment,
  [9970] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(630), 1,
      anon_sym_end,
    STATE(198), 1,
      sym_comment,
  [9983] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(632), 1,
      anon_sym_end,
    STATE(199), 1,
      sym_comment,
  [9996] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(634), 1,
      anon_sym_LPAREN,
    STATE(200), 1,
      sym_comment,
  [10009] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(636), 1,
      anon_sym_end,
    STATE(201), 1,
      sym_comment,
  [10022] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(638), 1,
      sym_identifier,
    STATE(202), 1,
      sym_comment,
  [10035] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(640), 1,
      anon_sym_end,
    STATE(203), 1,
      sym_comment,
  [10048] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(642), 1,
      sym_identifier,
    STATE(204), 1,
      sym_comment,
  [10061] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(644), 1,
      anon_sym_end,
    STATE(205), 1,
      sym_comment,
  [10074] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(646), 1,
      anon_sym_RBRACE,
    STATE(206), 1,
      sym_comment,
  [10087] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(648), 1,
      anon_sym_RPAREN,
    STATE(207), 1,
      sym_comment,
  [10100] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(650), 1,
      sym__string_end,
    STATE(208), 1,
      sym_comment,
  [10113] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(652), 1,
      anon_sym_RPAREN,
    STATE(209), 1,
      sym_comment,
  [10126] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(654), 1,
      anon_sym_RPAREN,
    STATE(210), 1,
      sym_comment,
  [10139] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(232), 1,
      ts_builtin_sym_end,
    STATE(211), 1,
      sym_comment,
  [10152] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(656), 1,
      sym__block_comment_end,
    STATE(212), 1,
      sym_comment,
  [10165] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(230), 1,
      ts_builtin_sym_end,
    STATE(213), 1,
      sym_comment,
  [10178] = 4,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(658), 1,
      anon_sym_DASH_DASH,
    ACTIONS(660), 1,
      aux_sym_comment_token1,
    STATE(214), 1,
      sym_comment,
  [10191] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(662), 1,
      anon_sym_end,
    STATE(215), 1,
      sym_comment,
  [10204] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(664), 1,
      ts_builtin_sym_end,
    STATE(216), 1,
      sym_comment,
  [10217] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(666), 1,
      anon_sym_end,
    STATE(217), 1,
      sym_comment,
  [10230] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(668), 1,
      sym__string_end,
    STATE(218), 1,
      sym_comment,
  [10243] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(670), 1,
      ts_builtin_sym_end,
    STATE(219), 1,
      sym_comment,
  [10256] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(672), 1,
      anon_sym_RPAREN,
    STATE(220), 1,
      sym_comment,
  [10269] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(674), 1,
      anon_sym_COLON_COLON,
    STATE(221), 1,
      sym_comment,
  [10282] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(676), 1,
      anon_sym_LPAREN,
    STATE(222), 1,
      sym_comment,
  [10295] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(678), 1,
      anon_sym_RBRACE,
    STATE(223), 1,
      sym_comment,
  [10308] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(680), 1,
      anon_sym_do,
    STATE(224), 1,
      sym_comment,
  [10321] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(682), 1,
      sym_identifier,
    STATE(225), 1,
      sym_comment,
  [10334] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(684), 1,
      sym_identifier,
    STATE(226), 1,
      sym_comment,
  [10347] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(686), 1,
      sym_identifier,
    STATE(227), 1,
      sym_comment,
  [10360] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(688), 1,
      sym_identifier,
    STATE(228), 1,
      sym_comment,
  [10373] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(690), 1,
      anon_sym_end,
    STATE(229), 1,
      sym_comment,
  [10386] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(610), 1,
      sym_identifier,
    STATE(230), 1,
      sym_comment,
  [10399] = 1,
    ACTIONS(692), 1,
      ts_builtin_sym_end,
  [10403] = 1,
    ACTIONS(694), 1,
      ts_builtin_sym_end,
  [10407] = 1,
    ACTIONS(696), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 65,
  [SMALL_STATE(4)] = 130,
  [SMALL_STATE(5)] = 195,
  [SMALL_STATE(6)] = 259,
  [SMALL_STATE(7)] = 323,
  [SMALL_STATE(8)] = 387,
  [SMALL_STATE(9)] = 451,
  [SMALL_STATE(10)] = 515,
  [SMALL_STATE(11)] = 579,
  [SMALL_STATE(12)] = 643,
  [SMALL_STATE(13)] = 707,
  [SMALL_STATE(14)] = 771,
  [SMALL_STATE(15)] = 839,
  [SMALL_STATE(16)] = 903,
  [SMALL_STATE(17)] = 962,
  [SMALL_STATE(18)] = 1021,
  [SMALL_STATE(19)] = 1106,
  [SMALL_STATE(20)] = 1171,
  [SMALL_STATE(21)] = 1254,
  [SMALL_STATE(22)] = 1333,
  [SMALL_STATE(23)] = 1394,
  [SMALL_STATE(24)] = 1455,
  [SMALL_STATE(25)] = 1526,
  [SMALL_STATE(26)] = 1587,
  [SMALL_STATE(27)] = 1664,
  [SMALL_STATE(28)] = 1723,
  [SMALL_STATE(29)] = 1798,
  [SMALL_STATE(30)] = 1871,
  [SMALL_STATE(31)] = 1930,
  [SMALL_STATE(32)] = 1989,
  [SMALL_STATE(33)] = 2116,
  [SMALL_STATE(34)] = 2175,
  [SMALL_STATE(35)] = 2234,
  [SMALL_STATE(36)] = 2305,
  [SMALL_STATE(37)] = 2364,
  [SMALL_STATE(38)] = 2472,
  [SMALL_STATE(39)] = 2560,
  [SMALL_STATE(40)] = 2674,
  [SMALL_STATE(41)] = 2786,
  [SMALL_STATE(42)] = 2869,
  [SMALL_STATE(43)] = 2981,
  [SMALL_STATE(44)] = 3093,
  [SMALL_STATE(45)] = 3205,
  [SMALL_STATE(46)] = 3287,
  [SMALL_STATE(47)] = 3399,
  [SMALL_STATE(48)] = 3511,
  [SMALL_STATE(49)] = 3593,
  [SMALL_STATE(50)] = 3705,
  [SMALL_STATE(51)] = 3814,
  [SMALL_STATE(52)] = 3923,
  [SMALL_STATE(53)] = 4032,
  [SMALL_STATE(54)] = 4114,
  [SMALL_STATE(55)] = 4193,
  [SMALL_STATE(56)] = 4272,
  [SMALL_STATE(57)] = 4319,
  [SMALL_STATE(58)] = 4395,
  [SMALL_STATE(59)] = 4471,
  [SMALL_STATE(60)] = 4547,
  [SMALL_STATE(61)] = 4619,
  [SMALL_STATE(62)] = 4692,
  [SMALL_STATE(63)] = 4762,
  [SMALL_STATE(64)] = 4832,
  [SMALL_STATE(65)] = 4902,
  [SMALL_STATE(66)] = 4972,
  [SMALL_STATE(67)] = 5039,
  [SMALL_STATE(68)] = 5106,
  [SMALL_STATE(69)] = 5173,
  [SMALL_STATE(70)] = 5240,
  [SMALL_STATE(71)] = 5307,
  [SMALL_STATE(72)] = 5374,
  [SMALL_STATE(73)] = 5441,
  [SMALL_STATE(74)] = 5508,
  [SMALL_STATE(75)] = 5575,
  [SMALL_STATE(76)] = 5642,
  [SMALL_STATE(77)] = 5709,
  [SMALL_STATE(78)] = 5776,
  [SMALL_STATE(79)] = 5843,
  [SMALL_STATE(80)] = 5910,
  [SMALL_STATE(81)] = 5977,
  [SMALL_STATE(82)] = 6044,
  [SMALL_STATE(83)] = 6111,
  [SMALL_STATE(84)] = 6178,
  [SMALL_STATE(85)] = 6245,
  [SMALL_STATE(86)] = 6312,
  [SMALL_STATE(87)] = 6379,
  [SMALL_STATE(88)] = 6446,
  [SMALL_STATE(89)] = 6513,
  [SMALL_STATE(90)] = 6580,
  [SMALL_STATE(91)] = 6647,
  [SMALL_STATE(92)] = 6714,
  [SMALL_STATE(93)] = 6781,
  [SMALL_STATE(94)] = 6821,
  [SMALL_STATE(95)] = 6885,
  [SMALL_STATE(96)] = 6949,
  [SMALL_STATE(97)] = 6991,
  [SMALL_STATE(98)] = 7059,
  [SMALL_STATE(99)] = 7123,
  [SMALL_STATE(100)] = 7160,
  [SMALL_STATE(101)] = 7225,
  [SMALL_STATE(102)] = 7266,
  [SMALL_STATE(103)] = 7328,
  [SMALL_STATE(104)] = 7390,
  [SMALL_STATE(105)] = 7452,
  [SMALL_STATE(106)] = 7514,
  [SMALL_STATE(107)] = 7576,
  [SMALL_STATE(108)] = 7638,
  [SMALL_STATE(109)] = 7700,
  [SMALL_STATE(110)] = 7762,
  [SMALL_STATE(111)] = 7802,
  [SMALL_STATE(112)] = 7839,
  [SMALL_STATE(113)] = 7878,
  [SMALL_STATE(114)] = 7914,
  [SMALL_STATE(115)] = 7947,
  [SMALL_STATE(116)] = 7980,
  [SMALL_STATE(117)] = 8013,
  [SMALL_STATE(118)] = 8046,
  [SMALL_STATE(119)] = 8079,
  [SMALL_STATE(120)] = 8112,
  [SMALL_STATE(121)] = 8145,
  [SMALL_STATE(122)] = 8178,
  [SMALL_STATE(123)] = 8211,
  [SMALL_STATE(124)] = 8244,
  [SMALL_STATE(125)] = 8277,
  [SMALL_STATE(126)] = 8310,
  [SMALL_STATE(127)] = 8343,
  [SMALL_STATE(128)] = 8376,
  [SMALL_STATE(129)] = 8409,
  [SMALL_STATE(130)] = 8442,
  [SMALL_STATE(131)] = 8475,
  [SMALL_STATE(132)] = 8508,
  [SMALL_STATE(133)] = 8541,
  [SMALL_STATE(134)] = 8574,
  [SMALL_STATE(135)] = 8607,
  [SMALL_STATE(136)] = 8640,
  [SMALL_STATE(137)] = 8673,
  [SMALL_STATE(138)] = 8706,
  [SMALL_STATE(139)] = 8739,
  [SMALL_STATE(140)] = 8772,
  [SMALL_STATE(141)] = 8805,
  [SMALL_STATE(142)] = 8838,
  [SMALL_STATE(143)] = 8868,
  [SMALL_STATE(144)] = 8897,
  [SMALL_STATE(145)] = 8926,
  [SMALL_STATE(146)] = 8952,
  [SMALL_STATE(147)] = 8985,
  [SMALL_STATE(148)] = 9012,
  [SMALL_STATE(149)] = 9047,
  [SMALL_STATE(150)] = 9074,
  [SMALL_STATE(151)] = 9096,
  [SMALL_STATE(152)] = 9122,
  [SMALL_STATE(153)] = 9150,
  [SMALL_STATE(154)] = 9178,
  [SMALL_STATE(155)] = 9196,
  [SMALL_STATE(156)] = 9224,
  [SMALL_STATE(157)] = 9246,
  [SMALL_STATE(158)] = 9267,
  [SMALL_STATE(159)] = 9290,
  [SMALL_STATE(160)] = 9313,
  [SMALL_STATE(161)] = 9336,
  [SMALL_STATE(162)] = 9355,
  [SMALL_STATE(163)] = 9380,
  [SMALL_STATE(164)] = 9399,
  [SMALL_STATE(165)] = 9421,
  [SMALL_STATE(166)] = 9439,
  [SMALL_STATE(167)] = 9459,
  [SMALL_STATE(168)] = 9481,
  [SMALL_STATE(169)] = 9503,
  [SMALL_STATE(170)] = 9521,
  [SMALL_STATE(171)] = 9540,
  [SMALL_STATE(172)] = 9559,
  [SMALL_STATE(173)] = 9578,
  [SMALL_STATE(174)] = 9595,
  [SMALL_STATE(175)] = 9610,
  [SMALL_STATE(176)] = 9625,
  [SMALL_STATE(177)] = 9642,
  [SMALL_STATE(178)] = 9661,
  [SMALL_STATE(179)] = 9680,
  [SMALL_STATE(180)] = 9697,
  [SMALL_STATE(181)] = 9716,
  [SMALL_STATE(182)] = 9731,
  [SMALL_STATE(183)] = 9750,
  [SMALL_STATE(184)] = 9765,
  [SMALL_STATE(185)] = 9780,
  [SMALL_STATE(186)] = 9799,
  [SMALL_STATE(187)] = 9815,
  [SMALL_STATE(188)] = 9831,
  [SMALL_STATE(189)] = 9847,
  [SMALL_STATE(190)] = 9863,
  [SMALL_STATE(191)] = 9879,
  [SMALL_STATE(192)] = 9892,
  [SMALL_STATE(193)] = 9905,
  [SMALL_STATE(194)] = 9918,
  [SMALL_STATE(195)] = 9931,
  [SMALL_STATE(196)] = 9944,
  [SMALL_STATE(197)] = 9957,
  [SMALL_STATE(198)] = 9970,
  [SMALL_STATE(199)] = 9983,
  [SMALL_STATE(200)] = 9996,
  [SMALL_STATE(201)] = 10009,
  [SMALL_STATE(202)] = 10022,
  [SMALL_STATE(203)] = 10035,
  [SMALL_STATE(204)] = 10048,
  [SMALL_STATE(205)] = 10061,
  [SMALL_STATE(206)] = 10074,
  [SMALL_STATE(207)] = 10087,
  [SMALL_STATE(208)] = 10100,
  [SMALL_STATE(209)] = 10113,
  [SMALL_STATE(210)] = 10126,
  [SMALL_STATE(211)] = 10139,
  [SMALL_STATE(212)] = 10152,
  [SMALL_STATE(213)] = 10165,
  [SMALL_STATE(214)] = 10178,
  [SMALL_STATE(215)] = 10191,
  [SMALL_STATE(216)] = 10204,
  [SMALL_STATE(217)] = 10217,
  [SMALL_STATE(218)] = 10230,
  [SMALL_STATE(219)] = 10243,
  [SMALL_STATE(220)] = 10256,
  [SMALL_STATE(221)] = 10269,
  [SMALL_STATE(222)] = 10282,
  [SMALL_STATE(223)] = 10295,
  [SMALL_STATE(224)] = 10308,
  [SMALL_STATE(225)] = 10321,
  [SMALL_STATE(226)] = 10334,
  [SMALL_STATE(227)] = 10347,
  [SMALL_STATE(228)] = 10360,
  [SMALL_STATE(229)] = 10373,
  [SMALL_STATE(230)] = 10386,
  [SMALL_STATE(231)] = 10399,
  [SMALL_STATE(232)] = 10403,
  [SMALL_STATE(233)] = 10407,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [39] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dot_index_expression, 3, .production_id = 20),
  [41] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dot_index_expression, 3, .production_id = 20),
  [43] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracket_index_expression, 4, .production_id = 20),
  [45] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bracket_index_expression, 4, .production_id = 20),
  [47] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 1),
  [49] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 1),
  [51] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [53] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [55] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [57] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [59] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_constructor, 3),
  [61] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_constructor, 3),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [65] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [67] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, .production_id = 12),
  [69] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, .production_id = 12),
  [71] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_constructor, 2),
  [73] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_constructor, 2),
  [75] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, .production_id = 5),
  [77] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, .production_id = 5),
  [79] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 2, .production_id = 10),
  [81] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 2, .production_id = 10),
  [83] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 1),
  [85] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 1),
  [87] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [89] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [91] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__prefix_expression, 1),
  [93] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__prefix_expression, 1),
  [95] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [97] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [99] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 2, .production_id = 24),
  [101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 2, .production_id = 24),
  [103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 25),
  [105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 25),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 15),
  [135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 15),
  [137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 2, .production_id = 13),
  [139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 2, .production_id = 13),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 3, .production_id = 33),
  [149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 3, .production_id = 33),
  [151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 2),
  [153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(4),
  [156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2),
  [158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(116),
  [161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(228),
  [164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(117),
  [167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(226),
  [170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(42),
  [173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(81),
  [176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(49),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(69),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(166),
  [185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(162),
  [188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(168),
  [191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 2), SHIFT_REPEAT(92),
  [194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_explist, 1, .production_id = 14),
  [196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_assignment_explist, 1, .production_id = 14),
  [198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_statement, 3, .production_id = 26),
  [204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 1),
  [206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, .production_id = 41),
  [208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, .production_id = 41),
  [210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_statement, 1),
  [216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 4, .production_id = 27),
  [218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 4, .production_id = 27),
  [220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 3, .production_id = 17),
  [226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 3, .production_id = 17),
  [228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 1),
  [232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 2),
  [234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1),
  [236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 1),
  [240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_list, 2),
  [266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_list, 1),
  [268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_list, 1),
  [272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_list, 3),
  [278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__expression_list_repeat1, 2),
  [280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__expression_list_repeat1, 2),
  [282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__name_list_repeat1, 2, .production_id = 23),
  [286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__name_list_repeat1, 2, .production_id = 23),
  [288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__name_list_repeat1, 2, .production_id = 23), SHIFT_REPEAT(230),
  [291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 1, .production_id = 14),
  [293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 3, .production_id = 34),
  [295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1),
  [297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 5, .production_id = 47),
  [303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__name_list_repeat1, 2, .production_id = 22),
  [305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__name_list_repeat1, 2, .production_id = 22),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_numeric_clause, 5, .production_id = 46),
  [311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name_list, 2, .production_id = 11),
  [313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__name_list, 2, .production_id = 11),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_numeric_clause, 7, .production_id = 49),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name_list, 1, .production_id = 4),
  [335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__name_list, 1, .production_id = 4),
  [337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, .production_id = 42),
  [339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, .production_id = 42),
  [341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, .production_id = 42), SHIFT_REPEAT(78),
  [344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_explist, 2, .production_id = 32),
  [346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_assignment_explist, 2, .production_id = 32),
  [348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, .production_id = 9),
  [350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 2, .production_id = 9),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 4, .production_id = 29),
  [356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 4, .production_id = 29),
  [358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 45),
  [360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 45),
  [362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 3, .production_id = 16),
  [368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 3, .production_id = 16),
  [370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label_statement, 3),
  [372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label_statement, 3),
  [374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, .production_id = 18),
  [376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 3, .production_id = 18),
  [378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 2),
  [380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 2),
  [382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 26),
  [384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 26),
  [386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 48),
  [388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 48),
  [390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 35),
  [392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 35),
  [394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 2),
  [396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 2),
  [398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 3, .production_id = 19),
  [400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_statement, 3, .production_id = 19),
  [402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__local_function_declaration, 4, .production_id = 31),
  [404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__local_function_declaration, 4, .production_id = 31),
  [406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, .production_id = 26),
  [408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, .production_id = 26),
  [410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2),
  [412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 2),
  [414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 37),
  [416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 37),
  [418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 44),
  [420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 44),
  [422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 43),
  [424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 43),
  [426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 36),
  [428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 36),
  [430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 1),
  [432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 1),
  [434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, .production_id = 1),
  [436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, .production_id = 1),
  [438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1),
  [442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 38),
  [444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 38),
  [446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, .production_id = 2),
  [448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, .production_id = 2),
  [450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, .production_id = 40),
  [452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, .production_id = 40),
  [454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, .production_id = 3),
  [456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, .production_id = 3),
  [458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__local_variable_assignment, 3, .production_id = 19),
  [460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__local_variable_assignment, 3, .production_id = 19),
  [462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_sep, 1),
  [464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_sep, 1),
  [466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, .production_id = 9),
  [468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, .production_id = 9),
  [470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2),
  [472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2),
  [474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_list_repeat1, 2), SHIFT_REPEAT(89),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_list, 2),
  [481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_list, 2),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_varlist, 1, .production_id = 4),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_varlist_repeat1, 2, .production_id = 22),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__field_list_repeat1, 2), SHIFT_REPEAT(142),
  [518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_list_repeat1, 2),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 39),
  [524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 39), SHIFT_REPEAT(85),
  [527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 39),
  [529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_list, 1),
  [531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 1),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 2),
  [555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 2),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name, 1),
  [565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_statement, 4, .production_id = 36),
  [567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_statement, 4, .production_id = 36),
  [569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_dot_index_expression, 3, .production_id = 20),
  [571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_index_expression, 3, .production_id = 21),
  [573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_varlist_repeat1, 2, .production_id = 23),
  [575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_assignment_varlist_repeat1, 2, .production_id = 23), SHIFT_REPEAT(146),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 1, .production_id = 4),
  [582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_varlist, 2, .production_id = 11),
  [584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 28),
  [586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 28),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 2, .production_id = 11),
  [594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_prefix_expression, 1, .production_id = 7),
  [596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_prefix_expression, 1),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_statement, 2, .production_id = 16),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name, 1, .production_id = 8),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 1),
  [654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 3, .production_id = 4),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 3),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [670] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 4, .production_id = 11),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_method_index_expression, 3, .production_id = 21),
  [678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_generic_clause, 3, .production_id = 30),
  [682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 3, .production_id = 12),
  [694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 2, .production_id = 6),
  [696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 2, .production_id = 5),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_lua_external_scanner_create(void);
void tree_sitter_lua_external_scanner_destroy(void *);
bool tree_sitter_lua_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_lua_external_scanner_serialize(void *, char *);
void tree_sitter_lua_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_lua(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_lua_external_scanner_create,
      tree_sitter_lua_external_scanner_destroy,
      tree_sitter_lua_external_scanner_scan,
      tree_sitter_lua_external_scanner_serialize,
      tree_sitter_lua_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
